var toId = 0,
	adId = 0,
	isReady = true,
	loadTimer = 0;

function closePullRefresh() {
	if (window.plus) {
		if (isReady) {
			if (loadTimer !== 0) {
				clearTimeout(loadTimer);
			}
			// 渲染50ms
			loadTimer = setTimeout(function() {
				isReady = false;
				ready();
			}, 50);
		}
	}
}

function goDetail(advertId, advertToId) {
	GLOBAL.webView.open({
		url: "../chat/chat",
		extras: {
			adId: advertId,
			toId: advertToId,
			messageType: 1
		}
	});
}

function buildDataHtm(data, bubble) {
	var advertToId = data.from_id;
	var advertId = data.advert_space_id;
	var nickname = data.nice_name;
	var headPic = data.head_pic;
	var lastContent = data.last_content;
	var viewDateTimeFormat = data.viewDateTimeFormat;

	if (headPic.indexOf("/") === 0) {
		headPic = GLOBAL.SERVER_URL + headPic;
	}

	var htm = '';
	htm += '<li data-toid="' + advertId + '-' + advertToId + '" class="mui-table-view-cell" onclick="goDetail(' + advertId + ', ' + advertToId + ')">';
	htm += '	<div class="l">';
	if (bubble) {
		htm += '	<span data-toid="' + advertId + '-' + advertToId + '" class="bubble" style="display: block;"></span>';
	} else {
		htm += '	<span data-toid="' + advertId + '-' + advertToId + '" class="bubble"></span>';
	}
	htm += '		<img src="' + headPic + '" alt="" />';
	htm += '	</div>';
	htm += '	<div class="m">';
	htm += '		<label>' + nickname + '</label>';
	htm += '		<span>' + lastContent + '</span>';
	htm += '	</div>';
	htm += '	<div class="r">';
	htm += '		<span>' + viewDateTimeFormat + '</span>';
	htm += '	</div>';
	htm += '</li>';
	return htm;
}

function removeBubble(ids) {
	$(".mui-table-view-cell .l .bubble[data-toid='" + ids + "']").hide();
}

function isBubbleShow(id, flag) {
	var bubble = false;
	var badge = plus.storage.getItem(flag + GLOBAL.token.get("user"));
	if (badge != null && badge.length > 0) {
		if (badge.indexOf(id) != -1) {
			bubble = true;
		}
	}
	return bubble;
}

function loadData() {
	GLOBAL.AJAX({
		url: GLOBAL.SERVER_URL + "/ad/myMessageUserList",
		data: {
			advert_space_id: adId
		},
		success_callback: function(response) {
			if (response.flag == "1") {
				var htm = "";
				var messages = response.messageUserList;
				for (var i = 0; i < messages.length; i++) {
					var advertToId = messages[i].from_id;
					var advertId = messages[i].advert_space_id;
					var bubble = isBubbleShow(advertId + "-" + advertToId, GLOBAL.PUSH.BADGE.MY_PROJECT.ID_KEY);
					htm += buildDataHtm(messages[i], bubble);
				}
				$("#list ul").html(htm);
				closePullRefresh();
			} else {
				closePullRefresh();
			}
		},
		error_callback: function() {
			closePullRefresh();
		}
	});
}

function chatListPushHandle(data) {
	data = JSON.parse(data);
	var fromId = data.from_id;
	var advertSpaceId = data.advert_space_id;
	var notityText = data.notityText;
	var viewDateTimeFormat = data.viewDateTimeFormat;

	var ids = advertSpaceId + "-" + fromId;
	var li = $(".mui-table-view-cell[data-toid='" + ids + "']");
	if (li.length > 0) {
		li.find(".m span").html(notityText);
		li.find(".r span").html(viewDateTimeFormat);
		li.find(".l .bubble").show();
		if (li.index() !== 0) {
			$(".mui-table-view-cell:first").before(li);
		}
	} else {
		var fromName = data.from_name;
		var fromHeadPic = data.from_head_pic;
		var htmData = {
			toId: fromId,
			adId: advertSpaceId,
			nickname: fromName,
			headPic: fromHeadPic,
			lastContent: notityText,
			viewDateTimeFormat: viewDateTimeFormat
		}
		var htm = buildDataHtm(htmData, true);
		$(".mui-table-view-cell:first").before(htm);
	}
}

function ready() {
	//$(".mui-bar .mui-title").bind("tap", function() {
	//	plus.webview.getLaunchWebview().evalJS("viewReceiverMsg();");
	//});
	GLOBAL.webView.get().show();
	plus.nativeUI.closeWaiting();
}

mui.plusReady(function() {
	var curView = GLOBAL.webView.get();
	adId = curView.adId;
	toId = curView.toId;
	loadData();
});