var toId = 0,
	adId = 0,
	messageType = 0,
	contentWebview = null,
	curPage = 0,
	chatTimeShowMax = 1000 * 60 * 30,
	isReady = true,
	loadTimer = 0;

function closeWin() {
	plus.storage.setItem("openChatPageIds", "a-a");
	GLOBAL.webView.close();
}

function closePullRefresh(page, flag) {
	if (window.plus) {
		if (isReady) {
			if (loadTimer !== 0) {
				clearTimeout(loadTimer);
			}
			// 渲染50ms
			loadTimer = setTimeout(function() {
				isReady = false;
				ready();
			}, 50);
		}
	}
}

function addChat(content) {
	var htm = buildDataHtm({
		content: content,
		oneself: true,
		head_pic: GLOBAL.token.get("headpic")
	});
	$("#chat-content ul").append(htm);
}

function addToChat(content, headPic, is2) {
	var is1 = adId + "-" + toId;
	if (is1 == is2) {
		var htm = buildDataHtm({
			content: content,
			oneself: false,
			head_pic: headPic
		});
		$("#chat-content ul").append(htm);
		toBottom();
	}
}

function buildDataHtm(data) {
	var content = data.content;
	var oneself = data.oneself;
	var headPic = data.head_pic;

	var className = 'chat';
	if (oneself) {
		className += ' my';
	}
	if (headPic.indexOf("/") === 0) {
		headPic = GLOBAL.SERVER_URL + headPic;
	}

	var htm = '';
	htm += '<li class="mui-table-view-cell ' + className + '">';
	htm += '	<div class="userFace">';
	htm += '		<img src="' + headPic + '">';
	htm += '	</div>';
	htm += '	<div class="userSay">';
	htm += '		<div class="inlineText">';
	htm += content;
	htm += '		</div>';
	htm += '	</div>';
	htm += '</li>';
	return htm;
}

function buildDataTime(t) {
	var htm = '';
	htm += '<li class="mui-table-view-cell chat timer">';
	htm += '	<span>' + t + '</span>';
	htm += '</li>';
	return htm;
}

function isTiemr(data, i) {
	var htm = '';
	if ((i + 1) !== data.length) {
		var time1 = data[i].create_time;
		time1 = new Date(time1.FormatTime()).getTime();
		var time2 = data[i + 1].create_time;
		time2 = new Date(time2.FormatTime()).getTime();
		if ((time1 - time2) > chatTimeShowMax) {
			htm = buildDataTime((new Date(time1)).Format("yyyy年MM月dd日 hh:mm:ss"));
		}
	} else {
		var time3 = data[i].create_time;
		time3 = new Date(time3.FormatTime()).getTime();
		htm = buildDataTime((new Date(time3)).Format("yyyy年MM月dd日 hh:mm:ss"));
	}
	return htm;
}

function toBottom() {
	var y = $("#chat-content")[0].scrollHeight + $("#chat-content ul")[0].offsetHeight;
	$("#chat-content").scrollTop(y);
}
window.addEventListener('resize', function() {
	toBottom();
}, false);

function loadMoreData(){
	loadData(curPage + 1);
}

function loadData(page) {
	GLOBAL.AJAX({
		url: GLOBAL.SERVER_URL + "/ad/messageSessionList",
		data: {
			pageSize: 15,
			curPage: page,
			advert_space_id: adId,
			to_id: toId,
		},
		success_callback: function(response) {
			if (response.flag == "1") {
				if (parseInt(response.page) > parseInt(response.total)) {
					page = -1;
				}
				if ((page === -1 && parseInt(response.page) <= 1) || page !== -1) {
					var htm = "";
					//加载data拼接html
					var messages = response.messageUserList;
					for (var i = 0; i < messages.length; i++) {
						htm = buildDataHtm(messages[i]) + htm;
						htm = isTiemr(messages, i) + htm;
					}
					
					
					$("#chat-content ul").prepend(htm);
					
					var htm1 = "";
					if(parseInt(response.page) < parseInt(response.total)){
						htm1 += '<li id="loadMore" class="mui-table-view-cell chat timer">';
						htm1 += '	<span onclick="loadMoreData()">查看更多</span>';
						htm1 += '</li>';
					}else{
//						htm1 += '<li id="loadMore" class="mui-table-view-cell chat timer">';
//						htm1 += '	<span>没有更早的记录了</span>';
//						htm1 += '</li>';
					}
					$("#loadMore").remove();
					$("#chat-content ul").prepend(htm1);
					
					curPage = parseInt(response.page);
					
					closePullRefresh(page);
				} else {
					closePullRefresh(page);
				}
			} else {
				closePullRefresh(page);
			}
		},
		error_callback: function() {
			closePullRefresh(page);
		}
	});
}

function load() {
	GLOBAL.AJAX({
		url: GLOBAL.SERVER_URL + "/ad/messageSessionListTitle",
		data: {
			advert_space_id: adId
		},
		success_callback: function(response) {
			if (response.flag == "1") {
				var tit = response.project_short_name + " - " + response.advert_space_name;
				if (parseFloat(response.advert_space_price) !== 0) {
					tit += " - " + response.advert_space_price;
				}
				$(".mui-bar .mui-title").html(tit);

				loadData(curPage + 1)
			}
		}
	});
}

function ready() {
	$("#inp-content").bind("input propertychange", function() {
		if ($(this).val()) {
			$("#send-btn").addClass("cur");
		} else {
			$("#send-btn").removeClass("cur");
		}
	});
	
	$("#send-btn").bind("touchstart", function(event) {
		$("#inp-content").focus();
		setTimeout(function() {
			$("#inp-content").focus();
		}, 150);
		event.preventDefault();
	});
	$("#send-btn").bind("touchmove", function(event) {
		$("#inp-content").focus();
		setTimeout(function() {
			$("#inp-content").focus();
		}, 150);
		event.preventDefault();
	});

	$("#send-btn").bind("release", function() {
		$("#inp-content").focus();
		toBottom();
		setTimeout(function() {
			$("#inp-content").focus();
		}, 150);
		var check = $(this).hasClass("cur");
		if (check) {
			var content = $("#inp-content").val();
			mui.ajax({
				'url': GLOBAL.SERVER_URL + "/ad/messageSend",
				'data': {
					advert_space_id: adId,
					to_id: toId,
					content: content
				},
				'type': "post",
				'dataType': "json",
				'timeout': 10000,
				'success': function(response) {
					if (response.flag == "1") {
						addChat(content);
						$("#inp-content").val("").focus();
						$("#send-btn").removeClass("cur");
						toBottom();
						setTimeout(function() {
							$("#inp-content").focus();
							toBottom();
						}, 150);
					}
				},
				'error': function(xhr, type, errorThrown) {
					if (ajaxToast === 0) {
						if (type == "timeout") {
							plus.nativeUI.toast("请求超时请您稍后再试!");
						} else {
							plus.nativeUI.toast("请求出现异常请您稍后再试!");
						}
					}
					_self.show_debug("ajax-error-xhr", JSON.stringify(xhr) + "----" + new Date().getTime());
					_self.show_debug("ajax-error-type", type + "----" + new Date().getTime());
					_self.show_debug("ajax-error-errorThrown", JSON.stringify(errorThrown) + "----" + new Date().getTime());
				}
			});
		}
	});
	var curView = GLOBAL.webView.get();
	adId = curView.adId;
	toId = curView.toId;
	curView.show();
	
	toBottom();
	
	removeBubble();
	
	plus.storage.setItem("openChatPageIds", adId + "-" + toId);
	var openChatPageIds = plus.storage.getItem("openChatPageIds");
}

function removeBubble() {
	var ids = adId + "-" + toId;
	var key1 = GLOBAL.PUSH.BADGE.MY_PROJECT.NUM_KEY;
	var key2 = GLOBAL.PUSH.BADGE.MY_PROJECT.ID_KEY;
	if (parseInt(messageType) !== 1) {
		key1 = GLOBAL.PUSH.BADGE.MY_QUESTION.NUM_KEY;
		key2 = GLOBAL.PUSH.BADGE.MY_QUESTION.ID_KEY;
	}
	key1 += GLOBAL.token.get("user");
	key2 += GLOBAL.token.get("user");
	var badge = plus.storage.getItem(key2);
	if (badge != null && badge.length > 0) {
		if (badge.indexOf(ids) != -1) {
			badge = badge.replace(ids + ",", "");
			plus.storage.setItem(key2, badge);
		}
	}

	var messageWebView = GLOBAL.webView.get("message");
	if (messageWebView !== null) {
		messageWebView.evalJS("removeBubble('" + ids + "');");
	}

	var chatListWebView = GLOBAL.webView.get("../chat/chat-list");
	if (chatListWebView !== null) {
		chatListWebView.evalJS("removeBubble('" + ids + "');");
	}

	var launchWebview = plus.webview.getLaunchWebview();
	launchWebview.evalJS("setDec('" + key1 + "',1);");
	//	launchWebview.evalJS("initBubble();");
}

mui.init({
	gestureConfig: {
		tap: true, //默认为true
		doubletap: true, //默认为false
		longtap: true, //默认为false
		swipe: true, //默认为true
		drag: true, //默认为true
		hold: true, //默认为false，不监听
		release: true //默认为false，不监听
	}
});

mui.plusReady(function() {
	var curView = GLOBAL.webView.get();
	adId = curView.adId;
	toId = curView.toId;
	messageType = curView.messageType;
	load();

	plus.webview.currentWebview().setStyle({
		softinputMode: "adjustResize"
	});
});