/**
 * 绑定个推
 * "token: "+info.token 
 * "clientid: "+info.clientid
 * "appid: "+info.appid
 * "appkey: "+info.appkey
 */
function bindUser() {
	var info = plus.push.getClientInfo();
	var data = "clientId=" + info.clientid;
	GLOBAL.AJAX({
		isWaiting: false,
		url: GLOBAL.SERVER_URL + "/webThirdparty/getuiBinding",
		data: data
	});
}

function setBadgeIds(numKey, key, id) {
	var isSet = false;
	var badge = plus.storage.getItem(key + GLOBAL.token.get("user"));
	if (badge !== 0 && badge !== null) {
		if (badge.indexOf(id) === -1) {
			badge += id + ",";
			isSet = true;
		}
	} else {
		badge = id + ",";
		isSet = true;
	}
	if (isSet) {
		plus.storage.setItem(key + GLOBAL.token.get("user"), badge);
		setInc(numKey + GLOBAL.token.get("user"), 1);
	}
}

function QTLogin() {
	var pushInfo = plus.push.getClientInfo();
	var clientid = pushInfo.clientid;
	GLOBAL.AJAX({
		url: GLOBAL.SERVER_URL + "/webThirdparty/loginOut",
		data: "clientid=" + clientid,
		success_callback: function(response) {
			if (response.flag == "1") {
				GLOBAL.token.clear();
				plus.oauth.getServices(function(services) {
					for (var i in services) {
						var service = services[i];
						service.logout(function(e) {}, function(e) {});
					}
				});
				GLOBAL.webView.open({
					url: 'member/login'
				});
				//GLOBAL.webView.close();
			}
		}
	});
}

/**
 *  客户端接收到推动消息的回调函数
 *  发送回执
 */
function viewReceiverMsg(msg) {
	var msgData = JSON.parse(msg.content);
	//var msgData = {
	//	"biz_type": "chatMessage",
	//	"to_id": "1",
	//	"project_owner_id": "1",
	//	"from_id": "7",
	//	"advert_space_id": "3",
	//	"project_short_name": "大侠如风",
	//	"advert_product_type_name": "手机",
	//	"project_pic": "/test/dxrf.jpg",
	//	"notityTitle": "push test",
	//	"notityText": "push test",
	//	"from_name": "淑女大月月",
	//	"from_head_pic": "/uploadImage/head_img/20160304/165904_jotdyp.jpg",
	//	"online_status": "true"
	//}
	//var msgData = {
	//	"biz_type": "sysMessage",
	//	"biz_sub_type": "memberAudit",
	//	"notityTitle": "push test",
	//	"notityText": "push test",
	//	"member_id": "1",
	//	"sysmessage_id": "60",
	//	"create_time": "20160310170730",
	//	"status": "1",
	//	"nice_name": "淑女大月月",
	//	"head_pic": "/uploadImage/head_img/20160304/165904_jotdyp.jpg",
	//	"online_status": "true"
	//}
	if (msgData.online_status == "true") {
		// 在线
		play_prompt();
	}
	
	//处理会话列表
	messagePush(msgData);

	//处理项目方在项目详情的会话列表
	chatListPush(msgData);

	//处理聊天页面
	chatPush(msgData);

	//处理系统消息列表
	sysMessagePush(msgData);
	
	if (msgData.biz_type == GLOBAL.PUSH.BIZ.OFFLINE) {
		plus.nativeUI.alert(msgData.notityText, function() {
			QTLogin();
		});
	} else if (msgData.biz_type == GLOBAL.PUSH.BIZ.CHAT) {
		var fromId = msgData.from_id;
		var toId = msgData.to_id;
		var projectOwnerId = msgData.project_owner_id;
		var advertSpaceId = msgData.advert_space_id;
		if (toId == projectOwnerId) {
			//我的项目
			setBadgeIds(GLOBAL.PUSH.BADGE.MY_PROJECT.NUM_KEY, GLOBAL.PUSH.BADGE.MY_PROJECT.ID_KEY, advertSpaceId + "-" + fromId);
		} else {
			//我的提问
			setBadgeIds(GLOBAL.PUSH.BADGE.MY_QUESTION.NUM_KEY, GLOBAL.PUSH.BADGE.MY_QUESTION.ID_KEY, advertSpaceId + "-" + fromId);
		}
	} else if (msgData.biz_type == GLOBAL.PUSH.BIZ.SYS) {
		var memberId = msgData.member_id;
		var sysmessageId = msgData.sysmessage_id;
		var bizSubType = msgData.biz_sub_type;
		var notityTitle = msgData.notityTitle;
		var notityText = msgData.notityText;
		if (bizSubType == GLOBAL.PUSH.BIZ.SYS_SUB.MEMBER.AUDI) {
			var niceName = msgData.nice_name;
			var headPic = msgData.head_pic;
			var status = msgData.status;
			var sameFlag = msgData.sameFlag;
			if (sameFlag == "true") {
				var sameMemberId = msgData.same_member_id;
				var sameNiceName = msgData.same_nice_name;
				var sameHeadPic = msgData.same_head_pic;

				var alertMsg = GLOBAL.PUSH.ALERT.same(niceName, sameNiceName);
				plus.nativeUI.alert(alertMsg, function() {
					QTLogin();
				}, "消息", "确定");
			} else {
				setBadgeIds(GLOBAL.PUSH.BADGE.SYS.NUM_KEY, GLOBAL.PUSH.BADGE.SYS.ID_KEY, sysmessageId);
			}
		} else {
			setBadgeIds(GLOBAL.PUSH.BADGE.SYS.NUM_KEY, GLOBAL.PUSH.BADGE.SYS.ID_KEY, sysmessageId);
		}
	}

	initBubble();
}

function sysMessagePush(data) {
	var sysmessage = GLOBAL.webView.get("sysmessage_data");
	if (sysmessage != null) {
		data = JSON.stringify(data);
		sysmessage.evalJS("sysMessagePushHandle('" + data + "');");
		GLOBAL.show_debug("pushMsg", "sysMessage");
	}
}

function chatListPush(data) {
	var chatList = GLOBAL.webView.get("../chat/chat-list");
	if (chatList != null) {
		data = JSON.stringify(data);
		chatList.evalJS("chatListPushHandle('" + data + "');");
		GLOBAL.show_debug("pushMsg", "chatList");
	}
}

function messagePush(data) {
	var message = GLOBAL.webView.get("message");
	if (message != null) {
		data = JSON.stringify(data);
		message.evalJS("messagePushHandle('" + data + "');");
		GLOBAL.show_debug("pushMsg", "message");
	}
}

function chatPush(data) {
	var fromId = data.from_id;
	var advertSpaceId = data.advert_space_id;
	var chatContent = GLOBAL.webView.get("../chat/chat2");
	if (chatContent != null) {
		var notityText = data.notityText;
		var fromHeadPic = data.from_head_pic;
		chatContent.evalJS("addToChat('" + notityText + "','" + fromHeadPic + "','" + advertSpaceId + "-" + fromId + "');");
		chatContent.evalJS("removeBubble();");
		GLOBAL.show_debug("pushMsg", "chat");
	}
}
