var projectId = 0,
	tagsId = 0,
	memberId = 0,
	advertEffectsId = 0;

function goWeb(url) {
	plus.runtime.openURL(url);
}

function loadData() {
	var win_w = $(window).width();
	if (memberId === 0) {
		memberId = GLOBAL.token.get("user");
	}
	GLOBAL.AJAX({
		isErrorClose: true,
		url: GLOBAL.SERVER_URL + "/ad/advertSpaceEffectsInfo",
		data: "advert_space_id=" + tagsId + "&advert_owner_id=" + memberId,
		success_callback: function(response) {
			if (response.flag == "1") {
				if (response.advertEffects) {
					advertEffectsId = response.advertEffects.advert_effects_id;
					var picUrls = response.pic_urls;
					var videoUrls = response.video_urls;
					var advertEffects = response.advertEffects;
					var content = response.advertEffects.effects_content;
					var replyContent = response.advertEffects.reply_content;
					var status = response.advertEffects.status;
					
					var hideBtn = function(){
						$("#effects-detail").css("padding-bottom", "15px");
						$("#effects-detail .btn").hide();
					}
					
					if (response.advertEffects.is_self) {
						hideBtn();
					}
					
					if (status == "1") {
						replyContent = '<span class="success">已达成</span>';
						hideBtn();
					} else if (status == "2") {
						replyContent = '<span class="fail">未达成</span><br/>' + replyContent;
						hideBtn();
					}else{
						if(response.advertEffects.is_self){
							replyContent = '<span class="wait">等待赞助商处理</span>';
						}
					}

					var htm = '<div class="replyContent">';
					htm += replyContent;
					htm += '</div>';

					htm += '<div class="text">';
					htm += content;
					htm += '</div>';
					if (picUrls) {
						htm += '<div class="pic">';
						for (var i = 0; i < picUrls.length; i++) {
							var img = picUrls[i];
							if (img.indexOf("/") === 0) {
								img = GLOBAL.SERVER_URL + img;
							}
							htm += '<img src="' + img + '" />';
						}
						htm += '</div>';
					}
					if (videoUrls) {
						htm += '<div class="video">';
						for (var i = 0; i < videoUrls.length; i++) {
							var video = $(videoUrls[i]);
							var video_w = parseInt(video.attr("width"));
							var video_h = parseInt(video.attr("height"));
							var videoSrc = video.attr("src");
							video_h = win_w * (video_h / video_w);
							video.attr("width", "100%");
							video.attr("height", video_h + "px");
							htm += '<div class="goweb" onclick="goWeb(\'' + videoSrc + '\')"></div>';
							htm += video[0].outerHTML;
						}
						htm += '</div>';
					}
					$("#effects-detail .content").html(htm);

				} else {
					plus.nativeUI.closeWaiting();
					GLOBAL.webView.close();
					plus.nativeUI.toast(GLOBAL.ADVERT_EFFECTS_PAGE.DETAIL_NOHAS);
				}
				ready();
			}
		}
	});
}

function bindClick() {
	$(".mui-content .btn a.btn-ok").click(function(event) {
		GLOBAL.stopClick(event);
		GLOBAL.AJAX({
			url: GLOBAL.SERVER_URL + "/ad/advertSpaceEffectsReplySave",
			data: "advert_effects_id=" + advertEffectsId + "&status=1",
			success_callback: function(response) {
				if (response.flag == "1") {
					$("#effects-detail").css("padding-bottom", "15px");
					$("#effects-detail .btn").hide();
					plus.nativeUI.toast("回馈成功！");
				}
			}
		});
	});
	$(".mui-content .btn a.btn-no").click(function(event) {
		GLOBAL.stopClick(event);
		$("#why-box").addClass("show");
	});

	$("#why-box .mui-bar.mui-bar-nav .mui-pull-left").click(function(event) {
		GLOBAL.stopClick(event);
		$("#why-box").removeClass("show");
	});

	$("#why-box .mui-content textarea").bind("input propertychange", function() {
		var content = $(this).val();
		var isPass = true;
		if (!content) {
			isPass = false;
		}
		if (content.length < 10) {
			isPass = false;
		}
		if (content.length > 300) {
			isPass = false;
		}
		if (isPass) {
			$("#why-box .mui-bar.mui-bar-nav .mui-pull-right").addClass("cur");
		} else {
			$("#why-box .mui-bar.mui-bar-nav .mui-pull-right").removeClass("cur");
		}
	});

	$("#why-box .mui-bar.mui-bar-nav .mui-pull-right").click(function(event) {
		GLOBAL.stopClick(event);
		var content = $("#why-box .mui-content textarea").val();
		if (!content) {
			plus.nativeUI.toast("原因" + GLOBAL.TOAST_MSG.VALIDATE.STR.NULL);
			return false;
		}
		if (content.length < 10) {
			plus.nativeUI.toast("原因" + GLOBAL.TOAST_MSG.VALIDATE.STR.LEN_MIN + "10个字！");
			return false;
		}
		if (content.length > 300) {
			plus.nativeUI.toast("原因" + GLOBAL.TOAST_MSG.VALIDATE.STR.LEN_MAX + "300个字！");
			return false;
		}
		GLOBAL.AJAX({
			url: GLOBAL.SERVER_URL + "/ad/advertSpaceEffectsReplySave",
			data: "reply_content=" + content + "&advert_effects_id=" + advertEffectsId + "&status=2",
			success_callback: function(response) {
				if (response.flag == "1") {
					$("#why-box .success-content").show();
					$("#why-box .mui-content").hide();
					$("#why-box .mui-bar.mui-bar-nav .mui-pull-right").hide();
					$("#effects-detail").css("padding-bottom", "15px");
					$("#effects-detail .btn").hide();
				}
			}
		});
	});

	$("#why-box .success-content a").click(function(event) {
		GLOBAL.stopClick(event);
		$("#why-box").removeClass("show");
	});
}

function ready() {
	bindClick();
	plus.nativeUI.closeWaiting();
	mui.currentWebview.show();
}

mui.plusReady(function() {
	var curView = GLOBAL.webView.get();
	projectId = curView.projectId;
	tagsId = curView.tagsId;
	memberId = curView.memberId;
	loadData();
});