var memberId = 0;

function buildHtm(response) {
	var member = response.member;
	var company = response.memberCompany;
	var headPic = member.head_pic;
	var nickName = member.nice_name;
	var realname = member.link_name;
	var weixin = member.weixin;
	var emial = member.email;
	var phone = member.link_phone;

	if (!headPic) {
		headPic = "../../img/member/default_head_img.png";
	} else {
		if (headPic.indexOf("/") === 0) {
			headPic = GLOBAL.SERVER_URL + headPic;
		}
	}
	$(".user-img img").attr("src", headPic);

	if (!nickName) {
		nickName = "暂无";
	}
	$("li.user-name span").html(nickName);

	if (!realname) {
		realname = "暂无";
	}
	$("li.user-realname span").html(realname);

	if (!emial) {
		emial = "暂无";
	}
	$("li.emial span").html(emial);

	if (!phone) {
		phone = "暂无";
	}
	$("li.phone span").html(phone);

	if (company) {
		var companyName = company.company_name;
		var dutyName = company.duty_name;

		if (!companyName) {
			companyName = "暂无";
		}
		$("li.company-name span").html(companyName);

		if (!dutyName) {
			dutyName = "暂无";
		}
		$("li.duty-name span").html(dutyName);
	}
}
// 上传头像
function uploadHeadImg() {
	var tabs_title = [{
		title: "拍照"
	}, {
		title: "我的相册"
	}];
	plus.nativeUI.actionSheet({
		cancel: "取消",
		buttons: tabs_title
	}, function(b) {
		switch (b.index) {
			case 0:
				break;
			case 1:
				getImage();
				break;
			case 2:
				galleryImg();
				break;
			default:
				break;
		}
	});
}

// 拍照获取
function getImage() {
	var c = plus.camera.getCamera();
	c.captureImage(function(e) {
		plus.io.resolveLocalFileSystemURL(e, function(fileEntity) {
			fileEntity.file(function(f) {
				//文件大小
				var file_size = f.size;
				var imgMaxSize = 5 * 1024 * 1024;
				if (file_size > imgMaxSize) {
					plus.nativeUI.toast("上传的文件不能大于5M!");
				} else {
					GLOBAL.webView.open({
						url: "cropper",
						extras: {
							path: "file:///" + fileEntity.fullPath,
							change: "cem"
						}
					});
				}
			}, function(e) {
				plus.nativeUI.toast("读取文件失败!");
			});
		}, function(e) {
			plus.nativeUI.toast(GLOBAL.TOAST_MSG.IMG.CAMERA_FILE + e.message);
		});
	}, function(e) {
		plus.nativeUI.toast(GLOBAL.TOAST_MSG.IMG.CAMERA + e);
	}, {
		filename: "_doc/headImg.jpg"
	});
}
// 相册获取
function galleryImg() {
	plus.gallery.pick(function(a) {
		plus.io.resolveLocalFileSystemURL(a, function(fileEntity) {
			fileEntity.file(function(f) {
				//文件大小
				var file_size = f.size;
				var imgMaxSize = 5 * 1024 * 1024;
				if (file_size > imgMaxSize) {
					plus.nativeUI.toast("上传的文件不能大于5M!");
				} else {
					GLOBAL.webView.open({
						url: "cropper",
						extras: {
							path: "file:///" + fileEntity.fullPath,
							change: "cem"
						}
					});
				}
			}, function(e) {
				plus.nativeUI.toast("读取文件失败!");
			});
		}, function(e) {
			plus.nativeUI.toast(GLOBAL.TOAST_MSG.IMG.FILE + e.message);
		});
	}, function(a) {}, {
		filter: "image"
	});
}


function bindClick() {
	// 头像裁剪后，替换原头像
	window.addEventListener("showHeadImg", function(e) {
		GLOBAL.SHOW_WAITING();
		$(".user-img img").attr("src", e.detail.head_img);
		saveHeadImg(e.detail.head_img);
	});

	// 更新个人信息数据
	window.addEventListener("replacePersonalData", function(e) {
		$("li.user-name span").html(e.detail.nickname);
	});

	$(".user-img img").bind('tap', function() {
		uploadHeadImg();
	});

	$("li.user-name span").bind('tap', function() {
		GLOBAL.webView.open({
			url: 'update-nickname',
			extras: {
				memberId: memberId,
				nickname: $("li.user-name span").html()
			}
		});
	});
}