var memberId = 0,
	projectType = 0,
	curPage = 0,
	imgLazyApi = null,
	isReady = true,
	loadTimer = 0,
	tagStyle = "";

function lazyImgs() {
	if (imgLazyApi === null) {
		imgLazyApi = mui(document).imageLazyload({
			autoDestroy: false,
		});
	} else {
		imgLazyApi.refresh(true);
	}
}

function goTopBar() {
	mui('#pullrefresh').pullRefresh().scrollTo(0, 0, 100);
}

function goDetail(id, tagId, event, state) {
	GLOBAL.stopClick(event);
	GLOBAL.webView.open({
		url: "../project/detail",
		extras: {
			proId: id,
			tagId: tagId,
		}
	});
}

function goMyDetail(id, tagId, state, event) {
	GLOBAL.stopClick(event);
	if (state == "已提交") {
		plus.nativeUI.toast("您的项目正在审核中，请耐心等待~");
	} else {
		GLOBAL.webView.open({
			url: "project-detail",
			extras: {
				proId: id,
				tagId: tagId,
			}
		});
		//plus.webview.getLaunchWebview().evalJS("clicked('member/project-detail',{proId:" + id + ",tagId:" + tagId + "});");
	}
}

function goAdvertEffects(id, tagId, event) {
	GLOBAL.stopClick(event);
	GLOBAL.webView.open({
		url: "advert-effects-detail",
		extras: {
			projectId: id,
			tagsId: tagId,
			memberId: 0
		}
	});
}

function closePullRefresh(page, flag) {
	if (window.plus) {
		if (isReady) {
			if (loadTimer !== 0) {
				clearTimeout(loadTimer);
			}
			// 渲染50ms
			loadTimer = setTimeout(function() {
				isReady = false;
				ready();
			}, 50);
		}
	}

	if (flag == "up") {
		if (page === -1) {
			if (!isReady) {
				plus.nativeUI.toast(GLOBAL.TOAST_MSG.NODATA);
			}
			mui('#pullrefresh').pullRefresh().endPullupToRefresh(true);
		} else {
			mui('#pullrefresh').pullRefresh().endPullupToRefresh(false);
			mui('#pullrefresh').pullRefresh().refresh(true);
		}
	} else {
		mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
		mui('#pullrefresh').pullRefresh().endPullupToRefresh(false);
		mui('#pullrefresh').pullRefresh().refresh(true);
	}
}

function buildImgAndState(img, state) {
	var htm = '';
	htm += '			<span class="state"><em>' + state + '</em></span>';
	htm += '			<img src="../../temp-img/project/not_find_img2.png" data-lazyload="' + img + '" alt="" />';
	return htm;
}

function buildNameAndIcon(projectName, guanzhu, showNum, chat, timer) {
	var htm = '';
	htm += '			<div class="name" >' + projectName + '</div>';
	htm += '			<div class="icon">';
	htm += '				<span class="guanzhu">' + guanzhu + '</span>';
	htm += '				<span class="timer">' + timer + '天</span>';
	htm += '				<span class="show-num">' + showNum + '</span>';
	htm += '				<span class="chat">' + chat + '</span>';
	htm += '			</div>';
	return htm;
}

function buildTags(id, tagsShowMaxNum, tags, clickName, state) {
	var htm = '';
	if (tags.length < tagsShowMaxNum) {
		tagsShowMaxNum = tags.length;
	}
	for (var i = 0; i < tagsShowMaxNum; i++) {
		//		if (i > 0) {
		htm += '<span class="tag" ' + tagStyle + ' data-id="' + id + '" data-tag-id="' + tags[i].advert_product_type_id + '" onclick="' + clickName + '(' + id + ',' + tags[i].advert_product_type_id + ',\'' + state + '\', event)" >' + tags[i].advert_product_type_name + '</span>';
		//		} else {
		//			htm += '<span class="tag active" ' + tagStyle + ' data-id="' + id + '"  data-tag-id="' + tags[i].advert_product_type_id + '" onclick="' + clickName + '(' + id + ',' + tags[i].advert_product_type_id + ', event)" >' + tags[i].advert_product_type_name + '</span>';
		//		}
	}
	return htm;
}

function buildMyProjectHtm(id, img, state, guanzhu, projectName, tags, timer, showNum, chat, haveIntention) {
	var htm = '';
	htm += '<li class="mui-table-view-cell project">';
	htm += '	<div class="box box-01" onclick="goMyDetail(' + id + ',-1,\'' + state + '\', event)">';
	htm += '		<div class="l" onclick="goMyDetail(' + id + ',-1,\'' + state + '\', event)">';
	htm += buildImgAndState(img, state);
	htm += '		</div>';
	htm += '		<div class="r">';
	htm += buildNameAndIcon(projectName, guanzhu, showNum, chat, timer);
	htm += '		</div>';
	htm += '	</div>';
	htm += '	<div class="box box-02">';
	htm += buildTags(id, 5, tags, "goMyDetail", state);
	if (haveIntention) {
		htm += '<span class="advert-effects" onclick="goMyDetail(' + id + ',' + tags[0].advert_product_type_id + ',\'' + state + '\', event)">效果回馈</span>';;
	}
	htm += '	</div>';
	htm += '</li>';
	return htm;
}

function buildMyIntentionHtm(id, img, state, guanzhu, projectName, tags, timer, showNum, chat, advertSpaceId, haveEffects) {
	var htm = '';
	htm += '<li class="mui-table-view-cell intention">';
	htm += '	<div class="box box-01" onclick="goDetail(' + id + ',-1,\'' + state + '\', event)">';
	htm += '		<div class="l" onclick="goDetail(' + id + ',-1,\'' + state + '\', event)">';
	htm += buildImgAndState(img, state);
	htm += '		</div>';
	htm += '		<div class="r">';
	htm += buildNameAndIcon(projectName, guanzhu, showNum, chat, timer);
	htm += '			<div class="box box-02">';
	htm += buildTags(id, 3, tags, "goDetail", state);
	if (haveEffects) {
		htm += '				<span class="advert-effects" onclick="goAdvertEffects(' + id + ',' + advertSpaceId + ', event)">回馈详情</span>';;
	}else {
		htm += '				<span class="advert-effects wait">等待回馈</span>';;
	}
	htm += '			</div>';
	htm += '		</div>';
	htm += '	</div>';
	htm += '</li>';
	return htm;
}

function buildMyFollowHtm(id, img, state, guanzhu, projectName, tags, timer, showNum, chat) {
	var htm = '';
	htm += '<li class="mui-table-view-cell follow" data-pro="' + id + '">';
	htm += '	<div class="mui-slider-right mui-disabled">';
	htm += '		<a class="mui-btn mui-btn-red" onclick="cancelGuanZhu(' + id + ',this, event)">取消关注</a>';
	htm += '	</div>';
	htm += '	<div class="mui-slider-handle">';
	htm += '	<div class="box box-01" onclick="goDetail(' + id + ',-1,\'' + state + '\', event)">';
	htm += '		<div class="l" onclick="goDetail(' + id + ',-1,\'' + state + '\', event)">';
	htm += buildImgAndState(img, state);
	htm += '		</div>';
	htm += '		<div class="r">';
	htm += buildNameAndIcon(projectName, guanzhu, showNum, chat, timer);
	htm += '		</div>';
	htm += '	</div>';
	htm += '	<div class="box box-02">';
	htm += buildTags(id, 5, tags, "goDetail", state);
	htm += '<span class="more" onclick="goDetail(' + id + ',' + tags[0].advert_product_type_id + ',\'' + state + '\', event)"></span>';;
	htm += '	</div>';
	htm += '	</div>';
	htm += '</li>';
	return htm;
}

function buildDataHtm(data) {
	var id = data.project_id;
	var img = data.project_pic;
	var state = data.status_name;
	var guanzhu = data.follow_num;
	var projectName = data.project_name;
	var timer = data.countdown_days;
	var showNum = data.click_num;
	var chat = data.message_num;
	var tags = data.advertProductTypeList;
	var advertSpaceId = data.advert_space_id;

	if (!img) {
		img = "../../temp-img/project/not_find_img2.png";
	} else {
		if (img.indexOf("/") === 0) {
			img = GLOBAL.SERVER_URL + img;
		}
	}

	var htm = '';
	if (parseInt(projectType) === 0) {
		var haveIntention = data.have_intention;
		htm = buildMyProjectHtm(id, img, state, guanzhu, projectName, tags, timer, showNum, chat, haveIntention);
	} else if (parseInt(projectType) === 1) {
		var haveEffects = data.have_effects;
		var intentionStatusName = data.intention_status_name;
		htm = buildMyIntentionHtm(id, img, intentionStatusName, guanzhu, projectName, tags, timer, showNum, chat, advertSpaceId, haveEffects);
	} else {
		htm = buildMyFollowHtm(id, img, state, guanzhu, projectName, tags, timer, showNum, chat);
	}
	return htm;
}