var messageType = 0,
	isReady = true,
	loadTimer = 0;

function closePullRefresh() {
	if (window.plus) {
		if (isReady) {
			if (loadTimer !== 0) {
				clearTimeout(loadTimer);
			}
			// 渲染50ms
			loadTimer = setTimeout(function() {
				isReady = false;
				ready();
			}, 50);
		}
	}
}

function goDetail(adId, toId) {
	GLOBAL.webView.open({
		url: "../chat/chat2",
		extras: {
			adId: adId,
			toId: toId,
			messageType: messageType
		}
	});
}

function buildProjectHtm(data, bubble) {
	var toId = data.from_id;
	var adId = data.advert_space_id;
	var adTags = data.advert_product_type_name;
	var nickname = data.nice_name;
	var headPic = data.head_pic;
	var lastContent = data.last_content;
	var projectShortName = data.project_short_name;

	if (headPic.indexOf("/") === 0) {
		headPic = GLOBAL.SERVER_URL + headPic;
	}

	var htm = '';
	htm += '<li data-toid="' + adId + '-' + toId + '" class="mui-table-view-cell project" onclick="goDetail(' + adId + ', ' + toId + ')">';
	htm += '	<div class="l">';
	if (bubble) {
		htm += '	<span data-toid="' + adId + '-' + toId + '" class="bubble" style="display: block;"></span>';
	} else {
		htm += '	<span data-toid="' + adId + '-' + toId + '" class="bubble"></span>';
	}
	htm += '		<img src="' + headPic + '" alt="" />';
	htm += '	</div>';
	htm += '	<div class="m">';
	htm += '		<label>' + nickname + '</label>';
	htm += '		<span>' + lastContent + '</span>';
	htm += '	</div>';
	htm += '	<div class="r">';
	htm += '		<span class="tags">' + adTags + '</span>';
	htm += '		<span class="project-name">' + projectShortName + '</span>';
	htm += '	</div>';
	htm += '</li>';
	return htm;
}

function goProDetail(id, tagId, event) {
	GLOBAL.stopClick(event);
	GLOBAL.webView.open({
		url: "../project/detail",
		extras: {
			proId: id,
			tagId: tagId,
		}
	});
	//plus.webview.getLaunchWebview().evalJS("clicked('project/detail',{proId:" + id + ",tagId:" + tagId + "});");
}

function buildQuestionHtm(data, bubble) {
	var toId = data.from_id;
	var adId = data.advert_space_id;
	var proId = data.project_id;
	var tagId = data.advert_product_type_id;
	var adTags = data.advert_product_type_name;
	var projectName = data.project_short_name;
	var projectPic = data.project_pic;
	var lastContent = data.last_content;
	var lastTime = data.last_time;
	var state = data.status_name;
	state = "招商中";

	if (projectPic.indexOf("/") === 0) {
		projectPic = GLOBAL.SERVER_URL + projectPic;
	}

	var htm = '';
	htm += '<li data-toid="' + adId + '-' + toId + '" class="mui-table-view-cell question" >';
	htm += '	<div class="l"  onclick="goProDetail(' + proId + ', ' + tagId + ', event)">';
	if (bubble) {
		htm += '	<span data-toid="' + adId + '-' + toId + '" class="bubble" style="display: block;"></span>';
	} else {
		htm += '	<span data-toid="' + adId + '-' + toId + '" class="bubble"></span>';
	}
	htm += '		<span class="state"><em>' + state + '</em></span>';
	htm += '		<img src="' + projectPic + '" alt="" />';
	htm += '	</div>';
	htm += '	<div class="m" onclick="goDetail(' + adId + ', ' + toId + ')">';
	htm += '		<label>' + projectName + '</label>';
	htm += '		<span>' + lastContent + '</span>';
	htm += '	</div>';
	htm += '	<div class="r" onclick="goDetail(' + adId + ', ' + toId + ')">';
	htm += '		<span class="tags">' + adTags + '</span>';
	htm += '		<span class="time">' + lastTime + '</span>';
	htm += '	</div>';
	htm += '</li>';
	return htm;
}

function removeBubble(ids) {
	$(".mui-table-view-cell .l .bubble[data-toid='" + ids + "']").hide();
}

function isBubbleShow(id, flag) {
	var bubble = false;
	var badge = plus.storage.getItem(flag + GLOBAL.token.get("user"));
	if (badge != null && badge.length > 0) {
		if (badge.indexOf(id) != -1) {
			bubble = true;
		}
	}
	return bubble;
}

function buildDataHtm(data) {
	var htm = '';
	var toId = data.from_id;
	var adId = data.advert_space_id;
	if (parseInt(messageType) === 1) {
		var bubble = isBubbleShow(adId + "-" + toId, GLOBAL.PUSH.BADGE.MY_PROJECT.ID_KEY);
		htm = buildProjectHtm(data, bubble);
	} else {
		var bubble = isBubbleShow(adId + "-" + toId, GLOBAL.PUSH.BADGE.MY_QUESTION.ID_KEY);
		htm = buildQuestionHtm(data, bubble);
	}
	return htm;
}

function noWifiShow(obj) {
	$(obj).height($(window).height() - 45).css("top", "45px");
	$(obj).show();
	$(window).resize(function() {
		$(obj).height($(window).height() - 45);
	});
}

function loadData() {
	var ajaxUrl = '';
	var tit = '';
	if (parseInt(messageType) === 1) {
		ajaxUrl = '/ad/myMessageUserList';
		tit = '我的项目';
	} else {
		ajaxUrl = '/ad/myAskMessageUserList';
		tit = '我的提问';
	}
	$(".mui-bar .mui-title").html(tit);

	//	$(".mui-bar .mui-title").bind("tap", function() {
	//		plus.webview.getLaunchWebview().evalJS("viewReceiverMsg();");
	//	});

	GLOBAL.AJAX({
		url: GLOBAL.SERVER_URL + ajaxUrl,
		success_callback: function(response) {
			if (response.flag == "1") {
				var htm = "";
				var messages = response.messageUserList;
				if (messages.length > 0) {
					for (var i = 0; i < messages.length; i++) {
						htm += buildDataHtm(messages[i]);
					}
					$("#list ul").html(htm);
				} else {
					if (parseInt(messageType) === 1) {
						noWifiShow($("#no-wifi.myproject"));
					} else {
						noWifiShow($("#no-wifi.myquestion"));
					}
				}
				closePullRefresh();
			} else {
				closePullRefresh();
			}
		},
		error_callback: function() {
			closePullRefresh();
		}
	});
}

function messagePushHandle(data) {
	data = JSON.parse(data);
	var fromId = data.from_id;
	var advertSpaceId = data.advert_space_id;
	var notityText = data.notityText;

	var ids = advertSpaceId + "-" + fromId;
	var li = $(".mui-table-view-cell[data-toid='" + ids + "']");
	if (li.length > 0) {
		li.find(".m span").html(notityText);
		li.find(".l .bubble").show();
		if (li.index() !== 0) {
			$(".mui-table-view-cell:first").before(li);
		}
	} else {
		var advertProductTypeName = data.advert_product_type_name;
		var projectShortName = data.project_short_name;
		var htm = '';
		if (messageType === 1) {
			var fromName = data.from_name;
			var fromHeadPic = data.from_head_pic;
			var htmData = {
				toId: fromId,
				adId: advertSpaceId,
				adTags: advertProductTypeName,
				nickname: fromName,
				headPic: fromHeadPic,
				lastContent: notityText,
				projectShortName: projectShortName
			}
			htm += buildProjectHtm(htmData, true);
		} else {
			var projectPic = data.project_pic;
			var htmData = {
				toId: fromId,
				adId: advertSpaceId,
				lastContent: notityText,
				projectPic: projectPic,
				projectShortName: projectShortName
			}
			htm += buildQuestionHtm(data, true);
		}
		$(".mui-table-view-cell:first").before(htm);
	}
}

function ready() {
	plus.storage.setItem("openMessageType", messageType);
	plus.nativeUI.closeWaiting();
	mui.currentWebview.show();
}

mui.plusReady(function() {
	var curView = GLOBAL.webView.get();
	messageType = curView.type;
	loadData();
});