/**
 *
 *  MD5 (Message-Digest Algorithm)
 *  http://www.webtoolkit.info/
 *
 **/
function MD5(string) {
	function RotateLeft(lValue, iShiftBits) {
		return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
	}

	function AddUnsigned(lX, lY) {
		var lX4, lY4, lX8, lY8, lResult;
		lX8 = (lX & 0x80000000);
		lY8 = (lY & 0x80000000);
		lX4 = (lX & 0x40000000);
		lY4 = (lY & 0x40000000);
		lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
		if (lX4 & lY4) {
			return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
		}
		if (lX4 | lY4) {
			if (lResult & 0x40000000) {
				return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
			} else {
				return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
			}
		} else {
			return (lResult ^ lX8 ^ lY8);
		}
	}

	function F(x, y, z) {
		return (x & y) | ((~x) & z);
	}

	function G(x, y, z) {
		return (x & z) | (y & (~z));
	}

	function H(x, y, z) {
		return (x ^ y ^ z);
	}

	function I(x, y, z) {
		return (y ^ (x | (~z)));
	}

	function FF(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	}

	function GG(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	}

	function HH(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	}

	function II(a, b, c, d, x, s, ac) {
		a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
		return AddUnsigned(RotateLeft(a, s), b);
	}

	function ConvertToWordArray(string) {
		var lWordCount;
		var lMessageLength = string.length;
		var lNumberOfWords_temp1 = lMessageLength + 8;
		var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
		var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
		var lWordArray = Array(lNumberOfWords - 1);
		var lBytePosition = 0;
		var lByteCount = 0;
		while (lByteCount < lMessageLength) {
			lWordCount = (lByteCount - (lByteCount % 4)) / 4;
			lBytePosition = (lByteCount % 4) * 8;
			lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition));
			lByteCount++;
		}
		lWordCount = (lByteCount - (lByteCount % 4)) / 4;
		lBytePosition = (lByteCount % 4) * 8;
		lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
		lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
		lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
		return lWordArray;
	}

	function WordToHex(lValue) {
		var WordToHexValue = "",
			WordToHexValue_temp = "",
			lByte, lCount;
		for (lCount = 0; lCount <= 3; lCount++) {
			lByte = (lValue >>> (lCount * 8)) & 255;
			WordToHexValue_temp = "0" + lByte.toString(16);
			WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length - 2, 2);
		}
		return WordToHexValue;
	}

	function Utf8Encode(string) {
		string = string.replace(/\r\n/g, "\n");
		var utftext = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			} else if ((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
		}
		return utftext;
	}
	var x = Array();
	var k, AA, BB, CC, DD, a, b, c, d;
	var S11 = 7,
		S12 = 12,
		S13 = 17,
		S14 = 22;
	var S21 = 5,
		S22 = 9,
		S23 = 14,
		S24 = 20;
	var S31 = 4,
		S32 = 11,
		S33 = 16,
		S34 = 23;
	var S41 = 6,
		S42 = 10,
		S43 = 15,
		S44 = 21;
	string = Utf8Encode(string);
	x = ConvertToWordArray(string);
	a = 0x67452301;
	b = 0xEFCDAB89;
	c = 0x98BADCFE;
	d = 0x10325476;
	for (k = 0; k < x.length; k += 16) {
		AA = a;
		BB = b;
		CC = c;
		DD = d;
		a = FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
		d = FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
		c = FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
		b = FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
		a = FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
		d = FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
		c = FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
		b = FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
		a = FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
		d = FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
		c = FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
		b = FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
		a = FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
		d = FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
		c = FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
		b = FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
		a = GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
		d = GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
		c = GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
		b = GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
		a = GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
		d = GG(d, a, b, c, x[k + 10], S22, 0x2441453);
		c = GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
		b = GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
		a = GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
		d = GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
		c = GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
		b = GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
		a = GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
		d = GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
		c = GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
		b = GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
		a = HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
		d = HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
		c = HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
		b = HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
		a = HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
		d = HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
		c = HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
		b = HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
		a = HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
		d = HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
		c = HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
		b = HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
		a = HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
		d = HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
		c = HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
		b = HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
		a = II(a, b, c, d, x[k + 0], S41, 0xF4292244);
		d = II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
		c = II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
		b = II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
		a = II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
		d = II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
		c = II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
		b = II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
		a = II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
		d = II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
		c = II(c, d, a, b, x[k + 6], S43, 0xA3014314);
		b = II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
		a = II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
		d = II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
		c = II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
		b = II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
		a = AddUnsigned(a, AA);
		b = AddUnsigned(b, BB);
		c = AddUnsigned(c, CC);
		d = AddUnsigned(d, DD);
	}
	var temp = WordToHex(a) + WordToHex(b) + WordToHex(c) + WordToHex(d);
	return temp.toLowerCase();
}

var _global = null;
(function() {
	var _update = function(opts) {
		this.global = opts.global;
	};
	_update.prototype = {
		global: "",
		cancelCallback: "",
		ui: "",
		url: "",
		updateCheck: function(hasCallback, cancelCallback) {
			var _self = this;
			plus.runtime.getProperty(plus.runtime.appid, function(app) {
				var currentVersion = app.version;
				_self.global.AJAX({
					isWaiting:false,
					url: _self.global.SERVER_URL + "/update/wgtuUpdateCheck",
					data: {
						"type": _self.global.USER_TYPE,
						"version": currentVersion
					},
					success_callback: function(response) {
						var flag = response.flag;
						if (flag == "1") {
							//是否有更新
							if (response.hasNew) {
								_self.openUpdateDiv(response);
								if (cancelCallback) {
									_self.cancelCallback = cancelCallback;
								}
							} else {
								if (hasCallback) {
									hasCallback();
								}
							}
						}
					},
					error_callback: function() {
						if (cancelCallback) {
							cancelCallback();
						}
					},
					ajaxToast: 1
				});
			});
		},
		update: function(url) {
			var _self = this;
			var wgtWaiting = plus.nativeUI.showWaiting("升级中...");
			var dtask = plus.downloader.createDownload(url, {
				method: "GET"
			}, function(d, status) {
				if (status == 200) {
					wgtWaiting.setTitle("正在配置环境...");
					plus.runtime.install(d.filename, {}, function() {
						_self.CLOSE_WAITING();
						plus.nativeUI.alert("更新完成, 应用将重启", function() {
							_self.setState();
							plus.runtime.restart();
						});
					}, function(e) {
						_self.CLOSE_WAITING();
						plus.nativeUI.alert("安装失败!" + e.code + "_____" + e.message);
					});
				} else {
					_self.CLOSE_WAITING();
				}
			});
			var i = 0,
				progress = 0;
			dtask.addEventListener('statechanged', function(d, status) {
				//				switch (d.state) {
				//					case 3:
				//						var percent = d.downloadedSize / d.totalSize * 100;
				//						if (percent === null || percent === undefined) percent = 0;
				//						wgtWaiting.setTitle("已下载 " + parseInt(percent) + "%");
				//						break;
				//				}
				if (status != 200) {
					progress = Math.round(d.uploadedSize / d.totalSize * 100);
					if (progress - i >= 5) {
						i += progress - i;
						if (progress == 100) {
							progress = 99.9
						}
						wgtWaiting.setTitle("已下载..." + progress + "%");
					}
				} else if (status == 200) {
					wgtWaiting.setTitle("已下载...100%");
				}
			});
			dtask.start();
		},
		openUpdateDiv: function(response) {
			plus.navigator.closeSplashscreen();
			var _self = this;
			var appUpdateHtml = '<div id="update-popover">' + '<div class="update-popover-bg"></div>' + '<div class="mui-popover-arrow"></div>' + '<div class="mui-content-padded">' + '<h4 class="title">发现新版本</h4>' + '<span class="new_version">最新版本：</span>' + '<span class="new_filesize">文件大小：</span>' + '<span class="publish_time">发布时间：</span>' + '<span class="version_tit">更新内容：</span>' + '<div class="version_note"><div class="scroll"></div></div>' + '<button type="button" class="mui-btn mui-btn-primary updateBtn">立即更新</button>' + '<button type="button" class="mui-btn unupdateBtn">以后再说</button>' + '</div>' + '</div>';
			var appDom = $(appUpdateHtml);
			_self.ui = {
				el: appDom,
				title: $('h4.title', appDom),
				newVersion: $('.new_version', appDom),
				newFilesize: $('.new_filesize', appDom),
				versionNote: $('.version_note', appDom),
				publish_time: $('.publish_time', appDom),
				versionNoteScroll: $('.scroll', appDom),
				updateBtn: $('.updateBtn', appDom),
				unupdateBtn: $('.unupdateBtn', appDom),
				updatePopoverBg: $('.update-popover-bg', appDom)
			};

			_self.ui.updateBtn.unbind("click");
			_self.ui.updateBtn.click(function() {
				_self.goUpdateBtn();
			});

			//是否强制更新
			if (response.enforce) {
				_self.ui.unupdateBtn.hide();
				_self.ui.updateBtn.addClass("center");
			} else {
				_self.ui.unupdateBtn.unbind("click");
				_self.ui.unupdateBtn.click(function() {
					_self.goUnUpdateBtn();
				});
				_self.ui.unupdateBtn.show();
			}
			_self.ui.newVersion.html("最新版本：" + response.new_version);
			_self.ui.newFilesize.html("文件大小：" + response.new_filesize);
			_self.ui.publish_time.html("发布时间：" + response.publish_time);
			_self.ui.versionNoteScroll.html(response.version_note);
			var deceleration = mui.os.ios ? 0.003 : 0.0009;
			mui(_self.ui.versionNote[0]).scroll({
				deceleration: deceleration,
				indicators: false

			});
			_self.url = response.update_url;

			if ($("#update-popover").length > 0) {
				$("#update-popover").remove();
			}
			$("body").append(_self.ui.el);
		},
		goUpdateBtn: function() {
			if (this.url) {
				$("#update-popover .update-popover-bg,#update-popover .mui-content-padded,#update-popover .mui-popover-arrow").hide();
				if (this.url.indexOf("itms-apps://") != -1) {
					plus.runtime.openURL(this.url);
				} else {
					this.update(this.url);
				}
			}
		},
		goUnUpdateBtn: function() {
			this.ui.el.remove();
			if (this.cancelCallback) {
				this.cancelCallback();
			}
		},
		setState: function() {
			plus.storage.setItem("update_state", '1');
		},
		getState: function() {
			var state = plus.storage.getItem("update_state");
			if (state == "1") {
				return true;
			}
			return false;
		},
		clearState: function() {
			plus.storage.removeItem("update_state");
		},
	};
	_global = function(opts) {
		this.init(opts);
	};
	_global.prototype = {
		debug: false,
		offline_server_url: "",
		online_server_url: "",
		offline_page_url: "",
		online_page_url: "",
		SERVER_URL: "",
		PAGE_URL: "",
		USER_TYPE: "",
		UTIL: "",
		update: "",
		WAITING: null,
		waitingOpt:"",
		show_debug: function(lab, msg) {
			var _self = this;
			if (_self.debug) {
				console.log(lab + "----" + msg);
			}
		},
		timestamp: function(lab) {
			var _self = this;
			_self.show_debug(lab, new Date().getTime());
		},
		stopClick: function(event) {
			var e = window.event || event;
			if (e.stopPropagation) {
				e.stopPropagation();
			} else {
				e.cancelBubble = true;
			}
		},
		getNetwork: function() {
			var _self = this;
			var state = plus.networkinfo.getCurrentType();
			_self.show_debug("网络连接状态", state + "----" + new Date().getTime());
			if (state == plus.networkinfo.CONNECTION_NONE || state == plus.networkinfo.CONNECTION_UNKNOW) {
				plus.nativeUI.toast("网络连接异常，请稍候重试！");
				return false;
			}
			return true;
		},
		getNetwork2: function() {
			var _self = this;
			var state = plus.networkinfo.getCurrentType();
			if (state == plus.networkinfo.CONNECTION_NONE || state == plus.networkinfo.CONNECTION_UNKNOW) {
				return false;
			}
			return true;
		},
		listenerNetwork: function(success, error) {
			var _self = this;
			document.addEventListener("netchange", function() {
				var state = plus.networkinfo.getCurrentType();
				_self.show_debug("getNetworkStatus-state", state + "----" + new Date().getTime());
				var types = {};
				types[plus.networkinfo.CONNECTION_UNKNOW] = "网络连接状态未知";
				types[plus.networkinfo.CONNECTION_NONE] = "当前设备网络未连接网络";
				//types[plus.networkinfo.CONNECTION_ETHERNET] = "当前设备连接到有线网络";
				//types[plus.networkinfo.CONNECTION_WIFI] = "当前设备连接到无线WIFI网络";
				//types[plus.networkinfo.CONNECTION_CELL2G] = "当前设备连接到蜂窝移动2G网络";
				//types[plus.networkinfo.CONNECTION_CELL3G] = "当前设备连接到蜂窝移动3G网络";
				//types[plus.networkinfo.CONNECTION_CELL4G] = "当前设备连接到蜂窝移动4G网络";
				var msg = types[state];
				if (msg) {
					if (error) {
						error();
					}
					return false;
				} else {
					if (success) {
						success();
					}
					return true;
				}
			}, false);
		},
		SHOW_WAITING: function() {
			var _self = this;
			if(!_self.waitingOpt){
				var waitingIcon = "";
				if(mui.os.android){
					var ah = plus.screen.resolutionHeight*plus.screen.scale;
					if(ah > 1280){
						waitingIcon = '_www/src/img/common/big_loading.png';
					}else{
						waitingIcon = '_www/src/img/common/loading.png';
					}
				}else{
					waitingIcon = '_www/src/img/common/loading';
				}
				_self.waitingOpt = {
					background: "rgba(0,0,0,0)",
					loading: {
						icon: waitingIcon
					}
				};
			}
			if(_self.WAITING === null){
				plus.nativeUI.closeWaiting();
				_self.WAITING = plus.nativeUI.showWaiting("", _self.waitingOpt);
			}
			return _self.WAITING;
		},
		CLOSE_WAITING:function() {
			var _self = this;
			plus.nativeUI.closeWaiting();
			_self.WAITING = null;
		},
		AJAX: function(opts) {
			var _self = this;
			if (opts.url) {
				var timeout = opts.timeout || 5000;
				var url = opts.url || "";
				var data = opts.data || {
					v: 0
				};
				var dataType = opts.dataType || "json";
				var type = opts.type || "post";
				var ajaxToast = opts.ajaxToast || 0;
				var isErrorClose = false || opts.isErrorClose;
				var errorClose = function() {
					if (isErrorClose) {
						_self.webView.get().close();
					} else {
						_self.CLOSE_WAITING();
						_self.webView.get().show();
					}
				};
				var successCallback = function(response) {
					_self.show_debug("ajax-success-callback", JSON.stringify(response) + "----" + new Date().getTime());
					if (response.flag != "1") {
						plus.nativeUI.toast(response.msg);
						errorClose();
					}
					if (opts.success_callback) {
						opts.success_callback(response);
					}
					_self.CLOSE_WAITING();
				};
				var errorCallback = function(xhr, type, errorThrown) {
					if (ajaxToast === 0) {
						if (type == "timeout") {
							plus.nativeUI.toast("请求超时请您稍后再试!");
							_self.CLOSE_WAITING();
						} else {
							plus.nativeUI.toast("请求出现异常请您稍后再试!");
							_self.CLOSE_WAITING();
						}
					}
					_self.show_debug("ajax-error-xhr", JSON.stringify(xhr) + "----" + new Date().getTime());
					_self.show_debug("ajax-error-type", type + "----" + new Date().getTime());
					_self.show_debug("ajax-error-errorThrown", JSON.stringify(errorThrown) + "----" + new Date().getTime());
					errorClose();
					if (opts.error_callback) {
						opts.error_callback(xhr, type, errorThrown);
					}
				};
				var isWaiting = false;
				if(typeof(opts.isWaiting) == 'undefined'){
					isWaiting = true;
				}else{
					isWaiting = opts.isWaiting;
				}
				if (_self.getNetwork()) {
					if(isWaiting){
						_self.SHOW_WAITING();
						_self.show_debug("开启Waiting... ","url："+url);
					}
					if (opts.before_callback) {
						opts.before_callback();
					}
					_self.timestamp("ajax-before-timer");
					mui.ajax({
						'url': url,
						'data': data,
						'type': type,
						'dataType': dataType,
						'timeout': timeout,
						'success': successCallback,
						'error': errorCallback
					});
					_self.timestamp("ajax-after-timer");
					if (opts.after_callback) {
						opts.after_callback();
					}
				} else {
					if (opts.network_callback) {
						network_callback();
					}
					plus.nativeUI.toast("当前网络异常请您稍后再试!");
					errorCallback();
					_self.CLOSE_WAITING();
				}
			} else {
				_self.show_debug("ajax-error", "url=undefined----" + new Date().getTime());
			}
		},
		open_keyboard: function(inpId) {
			if (mui.os.ios) {
				setTimeout(function() {
					var wv_current = plus.webview.currentWebview().nativeInstanceObject();
					wv_current.plusCallMethod({
						"setKeyboardDisplayRequiresUserAction": false
					});
					if (inpId) {
						$("#" + inpId).focus();
					}
				}, 330);
			} else {
				// 因为安卓autofocus只有4.0版本以上才支持，所以这里使用native.js来强制弹出
				setTimeout(function() {
					// 在执行的时候需要让当前webview获取焦点
					var wv_current = plus.android.currentWebview();
					plus.android.importClass(wv_current);
					wv_current.requestFocus();

					var Context = plus.android.importClass("android.content.Context");
					var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
					var main = plus.android.runtimeMainActivity();
					var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
					imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
					if (inpId) {
						$("#" + inpId).focus();
					}
				}, 330);
			}
		},
		webView: {
			open: function(opts) {
				var state = plus.networkinfo.getCurrentType();
				if (state == plus.networkinfo.CONNECTION_NONE || state == plus.networkinfo.CONNECTION_UNKNOW) {
					plus.nativeUI.toast("网络连接异常，请稍候重试！");
					return false;
				}
				var winShow = {
					autoShow: false
				};
				if (opts.show) {
					winShow = opts.show;
				}

				var view = plus.webview.getWebviewById(opts.url + ".html");
				if (view != null) {
					view.close("none");
				}

				var w = mui.openWindow({
					url: opts.url + ".html",
					id: opts.url,
					styles: opts.styles,
					extras: opts.extras,
					show: {
						autoShow: false
					},
					waiting: {
						autoShow: false
					}
				});
				return w;
			},
			get: function(id) {
				if (id) {
					return plus.webview.getWebviewById(id);
				} else {
					return plus.webview.currentWebview();
				}
			},
			hide: function(id) {
				var view = null;
				if (id) {
					view = plus.webview.getWebviewById(id + ".html");
				} else {
					view = plus.webview.currentWebview();
				}
				view.hide("none");
			},
			close: function(id, callback) {
				var view = null;
				if (id) {
					view = plus.webview.getWebviewById(id + ".html");
				} else {
					view = plus.webview.currentWebview();
				}
				if (callback) {
					callback(view);
				}
				view.close("none");
			}
		},
		token: {
			isNotNull: function() {
				if (plus.storage.getItem("app_token")) {
					return true;
				}
				return false;
			},
			get: function(flag) {
				if (flag == "user") {
					return plus.storage.getItem("app_user_id");
				} else if (flag == "tpc") {
					return plus.storage.getItem("app_thirdparty");
				} else if (flag == "headpic") {
					return plus.storage.getItem("app_user_headpic");
				} else {
					return plus.storage.getItem("app_token");
				}
			},
			set: function(opts) {
				if (opts.token) {
					plus.storage.setItem("app_token", opts.token);
				}
				if (opts.user_id) {
					plus.storage.setItem("app_user_id", "" + opts.user_id);
				}
				if (opts.tpc) {
					plus.storage.setItem("app_thirdparty", opts.tpc);
				}
				if (opts.headpic) {
					plus.storage.setItem("app_user_headpic", opts.headpic);
				}
			},
			clear: function() {
				var userId = plus.storage.getItem("app_user_id");
				plus.storage.removeItem("badge_project_" + userId);
				plus.storage.removeItem("badge_question_" + userId);
				plus.storage.removeItem("badge_sys_" + userId);
				plus.storage.removeItem("badge_msg_project_" + userId);
				plus.storage.removeItem("badge_msg_question_" + userId);
				plus.storage.removeItem("badge_msg_sys_" + userId);
				plus.storage.removeItem("badge_msg_" + userId);
				plus.storage.removeItem("badge_total_number_" + userId);
				plus.runtime.setBadgeNumber(0);

				plus.storage.removeItem("openChatPageIds");

				plus.storage.removeItem("app_token");
				plus.storage.removeItem("app_user_id");
				plus.storage.removeItem("app_thirdparty");
				plus.storage.removeItem("app_user_headpic");
			},
		},
		upload: {
			global: "",
			id: "",
			url: "",
			callback: "",
			pathKey: "",
			imgSize: 5,
			uploadAjax: function(path) {
				var _self = this;
				if (_self.url) {
					var wt = GLOBAL.SHOW_WAITING();
					var task = plus.uploader.createUpload(_self.url, {
							method: "POST"
						},
						function(t, status) { //上传完成
							if (status == 200) {
								if (_self.global) {
									_self.global.show_debug("uploadAjax", "上传成功!");
								}
								var data = JSON.parse(t.responseText);
								if (_self.callback) {
									_self.callback(data.pic_urls[0]);
								}
								wt.close();
							} else {
								if (_self.global) {
									_self.global.show_debug("uploadAjax", "上传失败：" + status);
								}
								wt.close();
							}
						}
					);
					task.addFile(path, {
						key: "upload_file"
					});
					//task.addData("path", _self.pathKey);
					task.start();
				} else {
					if (_self.callback) {
						_self.callback(path);
					}
				}
			},
			uploadFileGrab: function(path) {
				var _self = this;
				plus.io.resolveLocalFileSystemURL(path, function(fileEntity) {
					fileEntity.file(function(f) {
						//文件大小
						var file_size = f.size;
						var imgMaxSize = _self.imgSize * 1024 * 1024;
						if (file_size > imgMaxSize) {
							plus.nativeUI.toast("上传的文件不能大于" + _self.imgSize + "M!");
						} else {
							//上传照片
							_self.uploadAjax(path);
						}
					}, function(e) {
						plus.nativeUI.toast("读取文件失败!");
					});
				}, function(error) {
					plus.nativeUI.toast("读取文件失败!");
				});
			},
			galleryImg: function() {
				var _self = this;
				plus.gallery.pick(function(a) {
					plus.io.resolveLocalFileSystemURL(a, function(entry) {
						_self.uploadFileGrab(entry.toLocalURL());
					}, function(e) {
						if (_self.global) {
							_self.global.show_debug("galleryImg", "读取相册文件错误：" + e.message);
						}
					});
				}, function(a) {}, {
					filter: "image"
				});
			},
			getImage: function() {
				var _self = this;
				var c = plus.camera.getCamera();
				c.captureImage(function(e) {
					plus.io.resolveLocalFileSystemURL(e, function(entry) {
						_self.uploadFileGrab(entry.toLocalURL());
					}, function(e) {
						if (_self.global) {
							global.show_debug("getImage", "读取拍照文件错误：" + e.message);
						}
					});
				}, function(s) {
					if (_self.global) {
						global.show_debug("getImage", "error:" + s);
					}
				}, {
					filename: "_doc/" + _self.id + ".jpg"
				});
			},
			uploadImg: function(opts) {
				var _self = this;
				_self.global = opts.global || "";
				_self.id = opts.id || "advert_effects";
				_self.url = opts.url || "";
				_self.callback = opts.callback || "";
				_self.pathKey = opts.pathKey || "";
				_self.imgSize = opts.imgSize || 5;

				plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: [{
						title: "拍照"
					}, {
						title: "我的相册"
					}]
				}, function(b) {
					switch (b.index) {
						case 0:
							break;
						case 1:
							_self.getImage();
							break;
						case 2:
							_self.galleryImg();
							break;
						default:
							break;
					}
				});
			}
		},
		regex: {
			mobile: /^0?(13|15|17|18|14)[0-9]{9}$/,
			realName: /^([\u4e00-\u9fa5]+|([a-zA-Z]+\s?)+)$/,
			idCard: /^(^[1-9]\d{7}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}$)|(^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])((\d{4})|\d{3}[Xx])$)$/,
			number: /^[0-9]*$/,
			email: /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+$/,
			iframe: /<iframe[^>]+src="[a-zA-z]+:\/\/[^\s]*"+[^>]+><\/iframe>/,
			text: /[\u4e00-\u9fa5]/
		},
		PUSH: {
			BIZ: {
				OFFLINE: "offlineRequest",
				CHAT: "chatMessage",
				SYS: "sysMessage",
				SYS_SUB: {
					MEMBER: {
						AUDI: "memberAudit"
					}
				}
			},
			BADGE: {
				MY_PROJECT: {
					NUM_KEY: "msg_project_",
					ID_KEY: "badge_project_"
				},
				MY_QUESTION: {
					NUM_KEY: "msg_question_",
					ID_KEY: "badge_question_"
				},
				SYS: {
					NUM_KEY: "msg_sys_",
					ID_KEY: "badge_sys_"
				}
			},
			STORAGE: {
				OPEN_CHAT_IDS: "openChatIds"
			},
			ALERT: {
				same: function(niceName, sameNiceName) {
					var str = "您的帐号：" + sameNiceName + " 已审核通过!\n";
					str += "但系统检查出已有此手机号绑定的帐号：" + niceName + "\n";
					str += "系统将自动合并 " + niceName + " 和 " + sameNiceName + " 的帐号信息\n";
					str += "请重新登录，谢谢！";
					return str;
				},
			}
		},
		SYSMESSAGE: {
			same: function(niceName, sameNiceName, flag) {
				var str = '';
				if (flag) {
					str = "您的帐号：" + sameNiceName + " 已审核通过！但系统检查出已有此手机号绑定的帐号：" + niceName + "，";
					str += "系统已自动合并" + niceName + "和" + sameNiceName + "的帐号信息";
				} else {
					str = "您的帐号：" + niceName + " 已审核通过！";
				}
				return str;
			}
		},
		TOAST_MSG: {
			SMS: {
				SUCCESS: "短信已发送至您的手机，请注意查收！",
				LIMIT: "您发送次数过于频繁，请30分钟后重试！"
			},
			VALIDATE: {
				PHONE: {
					NULL: "手机号码不能为空！",
					ERROR: "请填写正确的手机号码！"
				},
				STR: {
					NULL: "不能为空！",
					LEN_MIN: "不能少于",
					LEN_MAX: "不能超过"
				},
				REALNAME: {
					ERROR: "请填写您的真实姓名！"
				},
				VAILD: {
					LEN: "请填写4位验证码！",
					TPYE: "验证码为数字类型！"
				},
				ADVERT_NULL: "请至少选择一种广告类型！"
			},
			IMG: {
				CAMERA_FILE: "读取拍照文件错误：",
				CAMERA: "打开摄像头错误：",
				FILE: "读取相册文件错误："
			},
			USER_THIRD: {
				INFO_ERROR: "获取用户信息失败：",
				THIRD1: "登录认证失败：",
				THIRD2: "获取登录认证失败：",
			},
			PROJECT: {
				NO_ADVERTEFFECTSADD: "该方案还在招商中~",
				GUANZHU_HAS: "此项目您已关注!",
				GUANZHU_SUCCESS: "关注成功！",
				GUANZHU_CANCEL: "取消关注！",
				NO_GUANZHU: "项目发布者不能关注自己的项目",
				NO_ADVERT1: "请您去点击有意向按钮，提交后再进行沟通！",
				NO_ADVERT2: "您的申请还没通过审核，审核通过后再进行沟通，请耐心等待！",
				NO_ADVERT3: "您已提交过该方案的意向，不要重复提交！",
				NO_INTENTION: "您无法为自己项目申请意向",

			},
			FEEDBACK: "反馈成功，感谢您的反馈，我们会及时处理，谢谢！",
			AUDIT: "请耐心等待我们的审核！",
			WAITING: "加载中...",
			NODATA: "没有更多数据了~",
		},
		INDEX_PAGE: {
			REPEAT_LOGIN: "该账号曾在其他地方登录过，请重新登录!",
		},
		CHAT_PAGE: {
			CONTENTDOWN: "下拉可以加载",
			CONTENTOVER: "释放立即加载",
			CONTENTREFRESH: "正在加载...",
			SEND_WAITING: "发送中..."
		},
		ADVERT_EFFECTS_PAGE: {
			DETAIL_NOHAS: "片方还没有填写效果回馈，请耐心等待！",
			VIDEO1: "视频代码不能包含中文！",
			VIDEO2: "视频代码格式不正确，请仔细检查代码，必须是通用iframe代码！"
		},
		AppShare: {
			shares: null,
			bhref: false,
			Intent: null,
			File: null,
			Uri: null,
			main: null,
			global: "",
			shareData: {
				href: "",
				title: "",
				content: "",
				img: ""
			},
			updateSerivces: function() {
				var _self = this;
				plus.share.getServices(function(s) {
					_self.shares = {};
					for (var i in s) {
						var t = s[i];
						_self.shares[t.id] = t;
					}
				}, function(e) {
					if (_self.global) {
						_self.global.show_debug("获取分享服务列表失败", e.message);
					}
				});
			},
			shareAction: function(id, ex) {
				var _self = this;
				var s = null;
				if (!id || !(s = _self.shares[id])) {
					if (_self.global) {
						_self.global.show_debug("分享操作", "无效的分享服务！");
					}
					return;
				}
				if (s.authenticated) {
					if (_self.global) {
						_self.global.show_debug("分享操作", "---已授权---");
					}
					_self.shareMessage(s, ex);
				} else {
					if (_self.global) {
						_self.global.show_debug("分享操作", "---未授权---");
					}
					s.authorize(function() {
						_self.shareMessage(s, ex);
					}, function(e) {
						if (_self.global) {
							_self.global.show_debug("认证授权失败：", e.code + " - " + e.message);
						}
					});
				}
			},
			shareMessage: function(s, ex) {
				var _self = this;
				var msg = {
					content: _self.shareData.content,
					extra: {
						scene: ex
					}
				};
				if (_self.bhref) {
					//					msg.href = _self.shareData.href;
					//					if (_self.shareData.title != null && _self.shareData.title.length > 0) {
					//						msg.title = _self.shareData.title;
					//					}
					//					if (_self.shareData.content != null && _self.shareData.content.length > 0) {
					//						msg.content = _self.shareData.content;
					//					}
					//					/*msg.thumbs=["_www/logo.png"];
					//					msg.pictures=["_www/logo.png"];*/
					//					//分享消息中包含的缩略图路径； 若分享平台仅支持提交一张图片，传入多张图片则仅提交第一张图片； 如果分享平台的信息不支持缩略图，若没有设置消息的图片（pictures）则使用缩略图，否则忽略其属性值。 
					//					//注意：图片有大小限制，推荐图片小于20Kb。
					//					var img = "_www/css/m/i/aut-0-1.png";
					//					if (_self.shareData.img) {
					//						img = _self.shareData.img;
					//					}
					msg.href = _self.shareData.href;
					msg.content = _self.shareData.content;
					msg.title = _self.shareData.title;
					msg.thumbs = [_self.shareData.img];
					msg.pictures = [_self.shareData.img];
				}
				s.send(msg, function() {
					plus.nativeUI.toast("分享成功！");
				}, function(e) {
					if (_self.global) {
						_self.global.show_debug("分享到\"" + s.description + "\"失败: ", e.code + " - " + e.message);
					}
					var sCode = e.message;
					sCode = sCode.substring(sCode.indexOf("["), sCode.indexOf("]"));
					sCode = sCode.substring(sCode.indexOf(":") + 1);
					if (sCode == "-2") {
						plus.nativeUI.toast("取消分享");
					} else {
						plus.nativeUI.toast("分享到\"" + s.description + "\"失败");
					}
				});
			},
			init: function() {
				var _self = this;
				_self.updateSerivces();
				if (plus.os.name == "Android") {
					_self.Intent = plus.android.importClass("android.content.Intent");
					_self.File = plus.android.importClass("java.io.File");
					_self.Uri = plus.android.importClass("android.net.Uri");
					_self.main = plus.android.runtimeMainActivity();
				}
			},
			share: function(opts) {
				var _self = this;
				_self.global = opts.g || "";
				_self.shareData = {
					href: opts.h || "",
					title: opts.t || "",
					content: opts.c || "",
					img: opts.i || ""
				}

				_self.init();
				_self.bhref = true;
				var ids = [{
					id: "weixin",
					ex: "WXSceneSession"
				}, {
					id: "weixin",
					ex: "WXSceneTimeline"
				}, {
					id: "qq"
				}];

				plus.nativeUI.actionSheet({
						cancel: "取消",
						buttons: [{
							title: "发送给微信好友"
						}, {
							title: "分享到微信朋友圈"
						}, {
							title: "分享到QQ"
						}]
					},
					function(e) {
						var i = e.index;
						if (i > 0) {
							var id = ids[i - 1];
							_self.shareAction(id.id, id.ex);
						}
					}
				);
			}
		},
		init: function(opts) {
			var _self = this;
			_self.debug = opts.debug || false;
			if (_self.debug) {
				_self.SERVER_URL = opts.offline_server_url || "";
				_self.PAGE_URL = opts.offline_page_url || "";
			} else {
				_self.SERVER_URL = opts.online_server_url || "";
				_self.PAGE_URL = opts.online_page_url || "";
			}
			_self.USER_TYPE = opts.user_type || 0;

			_self.update = new _update({
				global: _self
			});

			mui.ajaxSettings.beforeSend = function(xhr, settings) {
				_self.show_debug("ajax-para-old", JSON.stringify(settings));
				if (typeof settings.data === 'string' && settings.data.indexOf("{") !== 0) {
					if (settings.data !== '') {
						settings.data = settings.data + "&token=" + plus.storage.getItem("app_token") + "&deviceNum=" + MD5(plus.device.uuid);
					} else {
						settings.data = "token=" + plus.storage.getItem("app_token") + "&deviceNum=" + MD5(plus.device.uuid);
					}
				} else {
					settings.data.token = plus.storage.getItem("app_token");
					settings.data.deviceNum = MD5(plus.device.uuid);
				}
				_self.show_debug("ajax-para-new", JSON.stringify(settings));
			};

			String.prototype.trim = function() {
				return this.replace(/(^\s*)|(\s*$)/g, "");
			};

			String.prototype.FormatTime = function() {
				return this.substring(0, 4) + "/" + this.substring(4, 6) + "/" + this.substring(6, 8) + " " + this.substring(8, 10) + ":" + this.substring(10, 12) + ":" + this.substring(12, 14);
			};

			Date.prototype.Format = function(fmt) { //author: meizz 
				var o = {
					"M+": this.getMonth() + 1, //月份 
					"d+": this.getDate(), //日 
					"h+": this.getHours(), //小时 
					"m+": this.getMinutes(), //分 
					"s+": this.getSeconds(), //秒 
					"q+": Math.floor((this.getMonth() + 3) / 3), //季度 
					"S": this.getMilliseconds() //毫秒 
				};
				if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
				for (var k in o)
					if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
				return fmt;
			};

			String.prototype.replaceAll = function(str, substr, replacement) {
				if (replacement === null) {
					replacement = '';
				}
				str = str.replace(new RegExp(substr, 'gm'), replacement);
				return str;
			};
		}
	};
})();
var GLOBAL = new _global({
	debug: false,
	offline_server_url: "http://192.168.1.200:9001",
	online_server_url: "http://pp.qiiyue.com",
	offline_page_url: "src/page/",
	online_page_url: "src/page/"
});
// GLOBAL.show_debug("连接地址", GLOBAL.SERVER_URL);
// GLOBAL.show_debug("访问页面的地址", GLOBAL.PAGE_URL);
// GLOBAL.timestamp("test");
// GLOBAL.getNetwork();
// GLOBAL.listenerNetwork(function() {
// 	GLOBAL.show_debug("listenerNetwork", "1");
// }, function() {
// 	GLOBAL.show_debug("listenerNetwork", "0");
// });
// GLOBAL.AJAX({
// 	url: GLOBAL.SERVER_URL + "/test",
// 	data: {
// 		"type": GLOBAL.USER_TYPE
// 	},
// 	success_callback: function(response) {
// 		var flag = response.flag;
// 		if (flag == "1") {
// 			//do success something
// 		}
// 	},
// 	error_callback: function() {
// 		//error do something
// 	}
// });
// GLOBAL.open_keyboard("input-id");
// GLOBAL.webview.open({url:"index.html"},{top:"44px"});
// GLOBAL.webview.get("index.html");
// GLOBAL.webview.get();
// GLOBAL.webview.hide("index.html");
// GLOBAL.webview.hide();
// GLOBAL.webview.close("index.html",function(){alert("已关闭")});
// GLOBAL.webview.close(function(){alert("已关闭")});