var _global = null;
(function() {
	var _upload_img = function(opts) {
		var _self = this;
		_self.init(opts);
	};
	_upload_img.prototype = {
		fs: 0,
		fsm: 0,
		key: "upload_img_file_size",
		m_key: "",
		global: "",
		setFs: function(sm) {
			var _self = this;
			_self.fs = 1024 * 1024 * sm;
			_self.fsm = sm;
			if (_self.global) {
				_self.global.plus_storage.set(_self.key, _self.fs);
				_self.global.plus_storage.set(_self.m_key, _self.fsm);
			}
		},
		getFs: function() {
			var _self = this;
			if (_self.global) {
				var fs = _self.global.plus_storage.get(_self.key);
				var fsm = _self.global.plus_storage.get(_self.m_key);
				_self.fs = parseFloat(fs);
				_self.fsm = parseFloat(fsm);
			}
		},
		init: function(opts) {
			var _self = this;
			_self.key = opts.key || "upload_img_file_size";
			_self.m_key = _self.key + "_m";
			_self.global = opts.global || "";
		}
	};

	var _thirdparty_cookie = function(opts) {
		var _self = this;
		_self.init(opts);
	};
	_thirdparty_cookie.prototype = {
		key: "app_thirdparty_cookie",
		global: "",
		set: function(tpc) {
			var _self = this;
			if (_self.global) {
				_self.global.plus_storage.set(_self.key, tpc);
			}
		},
		get: function() {
			var _self = this;
			var tpc = "";
			if (_self.global) {
				tpc = _self.global.plus_storage.get(_self.key);
			}
			return tpc;
		},
		clear: function() {
			var _self = this;
			if (_self.global) {
				_self.global.plus_storage.clear(_self.key);
			}
		},
		init: function(opts) {
			var _self = this;
			_self.key = opts.key || "app_thirdparty_cookie";
			_self.global = opts.global || "";
		}
	};

	var _token = function(opts) {
		var _self = this;
		_self.init(opts);
	};
	_token.prototype = {
		key: "app_token",
		user_key: "app_token_user_id",
		global: "",
		thirdparty_cookie: "",
		set: function(token, user_id) {
			var _self = this;
			if (_self.global) {
				_self.global.plus_storage.set(_self.key, token);
				_self.global.plus_storage.set(_self.user_key, user_id);
			}
		},
		get: function() {
			var _self = this;
			var tokenval = "";
			if (_self.global) {
				tokenval = _self.global.plus_storage.get(_self.key);
			}
			return tokenval;
		},
		clear: function() {
			var _self = this;
			if (_self.global) {
				_self.global.plus_storage.clear(_self.key);
				_self.global.plus_storage.clear(_self.user_key);
			}
			if (_self.thirdparty_cookie) {
				_self.thirdparty_cookie.clear();
			}
		},
		init: function(opts) {
			var _self = this;
			_self.key = opts.key || "app_token";
			_self.user_key = _self.key + "_user_id";
			_self.global = opts.global || "";
			_self.thirdparty_cookie = opts.thirdparty_cookie || "";
		}
	};

	var _update_state = function(opts) {
		var _self = this;
		_self.init(opts);
	};
	_update_state.prototype = {
		key: "app_update_state",
		global: "",
		set: function(value_code) {
			var _self = this;
			if (_self.global) {
				_self.global.plus_storage.set(_self.key, value_code);
			}
		},
		get: function() {
			var _self = this;
			var tpc = "";
			if (_self.global) {
				tpc = _self.global.plus_storage.get(_self.key);
			}
			return tpc;
		},
		clear: function() {
			var _self = this;
			if (_self.global) {
				_self.global.plus_storage.clear(_self.key);
			}
		},
		init: function(opts) {
			var _self = this;
			_self.key = opts.key || "app_update_state";
			_self.global = opts.global || "";
		}
	};

	var _util = function(opts) {
		var _self = this;
		_self.init(opts);
	};
	_util.prototype = {
		global: "",
		upload_img: {},
		token: {},
		thirdparty_cookie: {},
		update_state: {},
		open_keyboard: {},
		network_status: {
			get: function() {},
			listener: function() {}
		},
		operateWebView: {
			getCur: function() {},
			closeCur: function() {}
		},
		addAttr: function(opts) {
			var _self = this;
			var attr_opts = opts || {};
			attr_opts.global = _self.global;
			attr_opts.plus = _self.plus;
			return attr_opts;
		},
		buildObj: function(opts) {
			var _self = this;
			var upload_img_opts = _self.addAttr({
				key: opts.upload_img_key
			});
			_self.upload_img = new _upload_img(upload_img_opts);

			var thirdparty_cookie_opts = _self.addAttr({
				key: opts.thirdparty_cookie_key
			});
			_self.thirdparty_cookie = new _thirdparty_cookie(thirdparty_cookie_opts);

			var update_state_opts = _self.addAttr({
				key: opts.update_state_key
			});
			_self.update_state = new _update_state(update_state_opts);

			var token_opts = _self.addAttr({
				key: opts.token_key,
				thirdparty_cookie: _self.thirdparty_cookie
			});
			_self.token = new _token(token_opts);
		},
		init: function(opts) {
			var _self = this;
			_self.global = opts.global;
			_self.buildObj(opts);
			_self.open_keyboard = opts.open_keyboard || function() {};
			_self.network_status = opts.network_status || function() {};
			_self.operateWebView = {
				getCur: opts.getCurWebView || function() {
					return false;
				},
				closeCur: opts.closeCurWebView || function() {}
			};
			_self.networkStatus = {
				get: opts.getNetworkStatus || function() {},
				listener: opts.listenerNetworkStatus || function() {}
			};

			String.prototype.trim = function() {
				return this.replace(/(^\s*)|(\s*$)/g, "");
			};

			Date.prototype.Format = function(fmt) { //author: meizz 
				var o = {
					"M+": this.getMonth() + 1, //月份 
					"d+": this.getDate(), //日 
					"h+": this.getHours(), //小时 
					"m+": this.getMinutes(), //分 
					"s+": this.getSeconds(), //秒 
					"q+": Math.floor((this.getMonth() + 3) / 3), //季度 
					"S": this.getMilliseconds() //毫秒 
				};
				if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
				for (var k in o)
					if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
				return fmt;
			};

			String.prototype.replaceAll = function(str, substr, replacement) {
				if (replacement === null) {
					replacement = '';
				}
				str = str.replace(new RegExp(substr, 'gm'), replacement);
				return str;
			};
		}
	};

	_global = function(opts) {
		var _self = this;
		_self.init(opts);
	};
	_global.prototype = {
		debug: false,
		offline_server_url: "",
		online_server_url: "",
		SERVER_URL: "",
		USER_TYPE: "",
		util: "",
		ajax: function() {},
		plus_storage: {
			global: "",
			setMainCallback: "",
			getMainCallback: "",
			clearMainCallback: "",
			set: function(key, val) {
				var _self = this;
				var msg = "0";
				if (_self.setMainCallback) {
					_self.setMainCallback(key, val + "");
					msg = "1";
				}
				if (_self.global) {
					_self.global.show_debug("s|" + key + "=" + tpc, msg);
				}
			},
			get: function(key) {
				var _self = this;
				var msg = "0";
				var val = "";
				if (_self.getMainCallback) {
					val = _self.getMainCallback(key);
					msg = "1";
				}
				if (_self.global) {
					_self.global.show_debug("g|" + key + "=" + val, msg);
				}
				return val;
			},
			clear: function(key) {
				var _self = this;
				var msg = "0";
				if (_self.clearMainCallback) {
					val = _self.clearMainCallback(key);
					msg = "1";
				}
				if (_self.global) {
					_self.global.show_debug("c|" + key, msg);
				}
			},
			init: function(opts) {
				var _self = this;
				_self.global = opts.global || "";
				_self.setMainCallback = opts.setMainCallback || "";
				_self.getMainCallback = opts.getMainCallback || "";
				_self.clearMainCallback = opts.clearMainCallback || "";
			}
		},
		show_debug: function(lab, msg) {
			var _self = this;
			if (_self.debug) {
				console.log(lab + "----" + msg);
			}
		},
		timestamp: function(lab) {
			var _self = this;
			_self.show_debug(lab, new Date().getTime());
		},
		init: function(opts) {
			var _self = this;
			_self.debug = opts.debug || false;
			if (_self.debug) {
				_self.SERVER_URL = opts.offline_server_url || "";
			} else {
				_self.SERVER_URL = opts.online_server_url || "";
			}
			_self.USER_TYPE = opts.user_type || 0;

			_self.ajax = opts.ajax || function() {};

			var plus_storage_opts = opts.plus_storage || "";
			plus_storage_opts.global = _self;
			_self.plus_storage = plus_storage_opts;

			var util_opts = opts.util || {};
			opts.util.global = _self;
			_self.util = new _util(util_opts);
		}
	};
})();

var GLOBAL = new _global({
	debug: true,
	offline_server_url: "http://192.168.1.106:8012",
	online_server_url: "http://101.201.220.49:10000",
	ajax: function(opts) {
		var _self = this;
		if (opts.url) {
			var timeout = opts.timeout || 10000;
			var url = opts.url || "";
			var data = opts.data || {};
			var success_callback = opts.success_callback || function() {};
			var dataType = opts.dataType || "json";
			var type = opts.type || "post";
			var error_callback = function(xhr, type, errorThrown) {
				if (type == "timeout") {
					plus.nativeUI.toast("请求超时请您稍后再试!");
				} else {
					plus.nativeUI.toast("请求出现异常请您稍后再试!");
				}
				_self.show_debug("ajax-error-xhr", JSON.stringify(xhr) + "----" + new Date().getTime());
				_self.show_debug("ajax-error-type", type + "----" + new Date().getTime());
				_self.show_debug("ajax-error-errorThrown", JSON.stringify(errorThrown) + "----" + new Date().getTime());
				if (opts.error_callback) {
					opts.error_callback(xhr, type, errorThrown);
				}
			};

			var isNetWork = function() {
				var state = plus.networkinfo.getCurrentType();
				if (state == plus.networkinfo.CONNECTION_NONE || state == plus.networkinfo.CONNECTION_UNKNOW) {
					return false;
				}
				return true;
			};
			if (isNetWork()) {
				if (opts.before_callback) {
					opts.before_callback();
				}
				_self.timestamp("ajax-before-timer");
				mui.ajax({
					'url': url,
					'data': data,
					'type': type,
					'dataType': dataType,
					'timeout': timeout,
					'success': success_callback,
					'error': error_callback
				});
				_self.timestamp("ajax-after-timer");
				if (opts.after_callback) {
					opts.after_callback();
				}
			} else {
				if (opts.network_callback) {
					network_callback();
				}
				plus.nativeUI.toast("当前网络异常请您稍后再试!");
			}
		} else {
			_self.show_debug("ajax-error", "url=undefined----" + new Date().getTime());
		}
	},
	plus_storage: {
		setMainCallback: function(key, val) {
			plus.storage.setItem(key, val + "");
		},
		getMainCallback: function(key) {
			plus.storage.getItem(key);
		},
		clearMainCallback: function(key) {
			plus.storage.removeItem(key);
		}
	},
	util: {
		upload_img_key: "upload_img_fs",
		token_key: "app_token",
		thirdparty_cookie_key: "app_thirdparty_cookie",
		update_state_key: "app_update_state",
		getNetworkStatus: function() {
			var _self = this;
			var state = plus.networkinfo.getCurrentType();
			_self.show_debug("getNetworkStatus-state", state + "----" + new Date().getTime());
			if (state == plus.networkinfo.CONNECTION_NONE || state == plus.networkinfo.CONNECTION_UNKNOW) {
				mui.toast("网络连接异常，请稍候重试！");
				return false;
			}
			return true;
		},
		listenerNetworkStatus: function(success, error) {
			var _self = this;
			document.addEventListener("netchange", function() {
				var state = plus.networkinfo.getCurrentType();
				_self.show_debug("getNetworkStatus-state", state + "----" + new Date().getTime());
				var types = {};
				types[plus.networkinfo.CONNECTION_UNKNOW] = "网络连接状态未知";
				types[plus.networkinfo.CONNECTION_NONE] = "当前设备网络未连接网络";
				//types[plus.networkinfo.CONNECTION_ETHERNET] = "当前设备连接到有线网络"; 
				//types[plus.networkinfo.CONNECTION_WIFI] = "当前设备连接到无线WIFI网络"; 
				//types[plus.networkinfo.CONNECTION_CELL2G] = "当前设备连接到蜂窝移动2G网络"; 
				//types[plus.networkinfo.CONNECTION_CELL3G] = "当前设备连接到蜂窝移动3G网络"; 
				//types[plus.networkinfo.CONNECTION_CELL4G] = "当前设备连接到蜂窝移动4G网络";
				var msg = types[state];
				if (msg) {
					if (error) {
						error();
					}
					return false;
				} else {
					if (success) {
						success();
					}
					return true;
				}
			}, false);
		},
		open_keyboard: function(inp) {
			if (mui.os.ios) {
				setTimeout(function() {
					var wv_current = plus.webview.currentWebview().nativeInstanceObject();
					wv_current.plusCallMethod({
						"setKeyboardDisplayRequiresUserAction": false
					});
					document.querySelector(inp).focus();
				}, 330);
			} else {
				// 因为安卓autofocus只有4.0版本以上才支持，所以这里使用native.js来强制弹出
				setTimeout(function() {
					// 在执行的时候需要让当前webview获取焦点
					var wv_current = plus.android.currentWebview();
					plus.android.importClass(wv_current);
					wv_current.requestFocus();

					var Context = plus.android.importClass("android.content.Context");
					var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
					var main = plus.android.runtimeMainActivity();
					var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
					imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
					document.querySelector(inp).focus();
				}, 330);
			}
		},
		getCurWebView: function() {
			return plus.webview.currentWebview();
		},
		closeCurWebView: function() {
			var view = plus.webview.currentWebview();
			view.close("none");
		}
	}
});
console.log(GLOBAL.SERVER_URL);