
/*
tmclient使用说明

1.构造tmclient对象，注册业务处理函数 
   var tmclient = new tmWebsocket({
	conf:{
		ip: "",
		port: "",
		protocol: "",
		userId: "",
		userType: "",
	},
	handler:[
		{tag_name:"tag1",tag_handler:tag1handler}
	]
});

2.注册的handler方法
var tag1_handler = function(data,senders){
  	console.debug("tag : tag1 , biz data : " + data+", senders : " + senders);
}

3.发送消息
tmclient。send(tag,senders,receivers,data)
 tag : 标识，例："a"
 senders ： 发送方,例："[{\"userType\":\"1\",\"userId\":\"101\"}]"
 receivers : 接收方，例："[{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType2\":\"1\",\"userId2\":\"99\"}]"
 data : 数据，例："{\"test\":\"test\",\"hehe\":\"haha\"}"

*/
var tmWebsocket = function(o) {
	this.run(o);
}

tmWebsocket.prototype = {
	tm_ws: null,
	handler: [],
	handlerMap: new Map(),
	debug:false,
	conf:{
		ip: "",
		port: "",
		protocol: "",
		userId: "",
		userType: "",
	},
	alert_msg:function(text){
		var _this = this;
		if(_this.debug){
			console.info(text);
		}
	},
	connect: function() {
		var _this = this;
		_this.tm_ws = $.websocket({
			domain: _this.conf.ip,
			port: _this.conf.port,
			protocol:_this.conf.protocol,
			onOpen: function(event) {
				_this.alert_msg("WebSocket#onOpen");
				var msg = "{\"tag\":\"connect\",\"userId\":\"" + _this.conf.userId + "\",\"userType\":\"" + _this.conf.userType + "\"}";
				_this.tm_ws.send(msg);
			},
			onClose: function(msg) {
				_this.alert_msg("WebSocket#onClose");
			},
			onError: function(event) {
				_this.alert_msg("WebSocket#onError");
				
			},
			onSend: function(msg) {
				_this.alert_msg("WebSocket#onSend");
			},
			onMessage: function(result, nTime) {
				_this.alert_msg("WebSocket#onMessage");
				_this.alert_msg("从服务端收到的数据:" + result);
				_this.alert_msg("最近一次发送数据到现在接收一共使用时间:" + nTime);
				//调用业务处理
				var resultIndex = result.lastIndexOf("}");
				var result_t = result.substring(0,resultIndex+1);
				var resultjson = JSON.parse(result_t);
				//if(_this.handlerMap.size > 0){
					var handler = _this.handlerMap.get(resultjson.tag);
					handler(resultjson.data,resultjson.senders);
//				}
			}
		});
	},
	send:function(tag_name,senders,receivers,data){
		var _this = this;
		//var test_msg = "{\"tag\":\"a\",\"senders\":[{\"userType\":\"1\",\"userId\":\"101\"}],\"receivers\":\"[{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType2\":\"1\",\"userId2\":\"99\"},{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType1\":\"1\",\"userId1\":\"100\"},{\"userType1\":\"1\",\"userId1\":\"100\"}]\",\"data\":{\"test\":\"test\"}}";
		var msg = "{\"tag\":\""+tag_name+"\",\"senders\":"+senders+",\"receivers\":"+receivers+",\"data\":"+data+"}";
		_this.alert_msg("发送的数据:" + msg);
		var send_result =  _this.tm_ws.send(msg);
		_this.alert_msg("发送数据时是否已链接:" + send_result);
        return send_result;
	},
	close:function(){
		var _this = this;
		_this.tm_ws.close();
	},
	isOpen:function(){
		var _this = this;
		_this.alert_msg("是否已建立链接:" + _this.tm_ws.isOpen());
		return _this.tm_ws.isOpen();
	},
	run:function(o){
		var _this = this;
		_this.conf = o.conf || {
			ip: "",
			port: "",
			protocol: "",
			userId: "",
			userType: "",
		}
		_this.handler = o.handler || [];
		_this.debug = o.debug || false;
		if(_this.handler.length > 0){
			for(var i = 0;i<_this.handler.length;i++){
				_this.handlerMap.put(_this.handler[i].tag_name,_this.handler[i].tag_handler);
			}
			_this.connect();
		}
	}
}